{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit configurarpro; 

{$mode objfpc}{$H+}

interface

uses
  StrUtils,globales,globales1,textomensajes,clmac,clhostmac,IniFiles,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons;

type
   Tdatosequipos=record
        ip:string;
        valordevuelto:string;
   end;

  { TfrmConPro }

  TfrmConPro = class(TForm)
    btnAceCon: TButton;
    btnColocar: TButton;
    btiConectar: TButton;
    btnSalir: TButton;
    bitModDNS: TButton;
    btnHallarMacHost: TButton;
    cboNumCol: TComboBox;
    cboNumOrd: TComboBox;
    cboNMI: TComboBox;
    chkDesInt: TCheckBox;
    chkCanon: TCheckBox;
    cboDistribucion: TComboBox;
    cboInicio: TComboBox;
    cboCanonTiempo: TComboBox;
    chkRatTecIna: TCheckBox;
    edAlumno: TEdit;
    edProfe: TEdit;
    edContra: TEdit;
    edServidor: TEdit;
    edVlc: TEdit;
    Image1: TImage;
    imgFondo: TImage;
    imlOrd: TImageList;
    Label1: TLabel;
    Label79: TLabel;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    Label83: TLabel;
    Label84: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    Label88: TLabel;
    Label89: TLabel;
    lblMensaje: TLabel;
    opAutomatico: TRadioButton;
    opPersonal: TRadioButton;
    pnMac: TPanel;
    tmrMAC: TTimer;
    tmrDatos1: TTimer;
    procedure bitModDNSClick(Sender: TObject);
    procedure btiConectarClick(Sender: TObject);
    procedure btnAceConClick(Sender: TObject);
    procedure btnColocarClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure btnHallarMacHostClick(Sender: TObject);
    procedure cboDistribucionChange(Sender: TObject);
    procedure cboInicioChange(Sender: TObject);
    procedure cboNMIChange(Sender: TObject);
    procedure cboNMIClick(Sender: TObject);
    procedure cboNumColChange(Sender: TObject);
    procedure cboNumColClick(Sender: TObject);
    procedure cboNumOrdChange(Sender: TObject);
    procedure cboNumOrdKeyPress(Sender: TObject; var Key: char);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);

    procedure opPersonalChange(Sender: TObject);
    procedure tmrDatos1Timer(Sender: TObject);
    procedure tmrMACTimer(Sender: TObject);
  private
    procedure buscaMAC;
    procedure CargarDatosEquipos();
    procedure CrearEtiquetasOr();
    procedure CrearOrdenadores();
    procedure edIPKeyPress(Sender: TObject; var Key: Char);
    procedure edMACKeyPress(Sender: TObject; var Key: Char);
    procedure edOrdKeyPress(Sender: TObject; var Key: Char);
    procedure EscribirSetupIni(nf: string);
    procedure GuardarCambios();
    procedure HallarNombresEquipos();
    procedure lblordclick(sender: Tobject);
    procedure LeerSetupIni;
    procedure MostrarDatos(numequipo, tdatos: integer);
    procedure MostrarOrdenadores(numaula, numpan: integer);
    function NumOrdPantalla(Or_Au: integer): integer;
    procedure OcultarOrdenatas;
    procedure OrdenadoresCombo(no: integer; cboC: TCombobox);
    procedure RellenaMACIPEquipo(sHostMac: string; numVariable: integer);
    procedure TipoDiseno(tipo: integer);
    function ValidarDatos: boolean;

    { private declarations }
  public
    fEquipos:array[0..53] of Tdatosequipos;
    procedure MostrarPersonal();
    procedure refrescarMAC(numero: integer; conectado: boolean; mmac: string);
    procedure refrescarHostMAC();
    procedure cargarRespuestas(numero:integer;sHostMac:string);
    { public declarations }
  end; 

var
  frmConPro: TfrmConPro;
  OrdCon:array[0..23] of TSpeedButton;
  lblOrd:array[0..23] of Tlabel;
  edOrd:array[0..23] of TEdit;
  edMAC:array[0..23] of TEdit;
  edIP:array[0..23] of TEdit;
  fcontador:integer;
  ftiempo:integer=180;
  misrespuestas: array [0..53] of string;
  misips: array [0..53] of string;



implementation
uses inicio,colocar;
const
    CONTRA_PROGRAMA:string='moma007';
    IP_GATEWAY:string='/sbin/route -n| grep UG |grep "0.0.0.0"| tr -s " " | cut -f2 -d" "';
    ORD_INICIAR_AULALINEX:string='/usr/bin/aulalinex-profesor-ltsp &';
var
    f_ContraCorrecta:boolean=false;
    f_iniciando:boolean=false;
    f_etiqueta_pulsada:integer=0;
    f_equipohallados:integer=0;
{ TfrmConPro }
procedure TfrmConPro.btnHallarMacHostClick(Sender: TObject);
    var
       i,numorde:integer;
    begin
        if length(cbonumord.Text)<1 then
            begin
                mensaje(MEN_ELIGE_NUM_ORD,aceptar);
                exit;
            end;
        if mensaje(MEN_ORDENADORES_ENCENDIDOS,sino)=2 then exit;
        enabled:=false;
        cursor:=crHourGlass;
        pnMac.visible:=true;
        numorde:= strtoint(cboNumOrd.text);
        for i:=0 to numorde -1 do
            begin
                edMAC[i].text:='00:00:00:00:00:00';
                edIP[i].text:='';
                OrdCon[i].Down:=true;
            end;
        Application.ProcessMessages;
        f_equipohallados:=0;
        application.ProcessMessages;
        CargarDatosEquipos();
        tmrDatos1.enabled:=true;
    end;

procedure TfrmConPro.CargarDatosEquipos();
    var
        i:integer;
    begin
       for i:=0 to high(fEquipos) do
           begin
               misips[i]:='192.168.0.'+inttostr(200+i);
               with ThrHostMAC.create(i,misips[i]) do Resume;
               Application.ProcessMessages;
           end;
    end;

procedure TfrmConPro.cargarRespuestas(numero:integer;sHostMac:string);
    begin
        misrespuestas[numero]:=sHostMac;
        inc(f_equipohallados);
    end;

procedure TfrmConPro.refrescarHostMAC();
    var
       sHostMac:string;
       j:integer;
    begin
          try
              try
                  for j:=0 to high(misrespuestas) do
                      begin
                          sHostMac:=misrespuestas[j];
                          RellenaMACIPEquipo(sHostMac,j);
                       end;
                      pnMAC.Visible:=false;
                   mensaje(MEN_MAC_HALLADAS, aceptar);
              except
                   mensaje(MEN_ERROR_HALLAR_MAC,Aceptar);
              end;
          finally
              pnMAC.Visible:=false;
              cursor:=crDefault;
              enabled:=true;
          end;
     end;

procedure TfrmConPro.RellenaMACIPEquipo(sHostMac:string;numVariable:integer);
    var
        posc,posc1,numeroequipos,i:integer;
        snombre,smac,sip:string;
    begin
        posc:=pos('#',sHostMac);
        if posc = 0 then exit;
        numeroequipos:=strtoint(cboNumOrd.text);
        snombre:=trim(LeftStr(sHostMac,posc-1));
        posc1:=Length(sHostMac)-posc;
        smac:=trim(RightStr(sHostMac,posc1));
        sip:=trim(misips[numVariable]);
        writeln('nombre: '+ snombre +  '; IP: '+ sip +'; MAC: '+ smac);
        for i:=0 to numeroequipos -1 do
            begin
                if trim(edOrd[i].text)=snombre then
                    begin
                        edOrd[i].text:=snombre;
                        edmac[i].text:=smac;
                        edip[i].text:=sip;
                        OrdCon[i].Down:=false;
                        application.ProcessMessages;
                        break;
                    end;
            end;
    end;

procedure TfrmConPro.refrescarMAC(numero:integer;conectado:boolean;mmac:string);
    begin
        edmac[numero].text:=mmac;
        OrdCon[numero].Down:=not conectado;
    end;

Procedure TfrmConPro.TipoDiseno(tipo:integer);
    begin
        cboNumCol.Enabled:=tipo=0;
        cboDistribucion.enabled:=tipo=0;
        cboInicio.enabled:=tipo=0;
        if tipo=1 then cboNumOrd.Enabled:=false;
        opAutomatico.Checked:=tipo=0;
        opPersonal.Checked:=tipo=1;
        btnColocar.Enabled:=tipo=1;
        ocultarordenatas;
        if (tipo=0) then
            MostrarOrdenadores(g_num_diseno,NumOrdPantalla(g_num_diseno))
        else if (tipo=1) and (g_num_diseno>0) then
            MostrarPersonal;
    end;

Function TfrmConPro.ValidarDatos:boolean;
    var
        TextoMensaje:string;
        i:integer;
        todosinvisibles:boolean;
    begin
       textomensaje:='';
       todosinvisibles:=true;
        for i:=0 to high(OrdCon) do
        if OrdCon[i].visible=true then
                todosinvisibles:=false;
        if length(edprofe.Text)<3 then
            TextoMensaje:=MEN_INDICA_IP_PROFESOR
        else if g_num_diseno=0 then
            TextoMensaje:=MEN_NUMERO_ORDENADORES
        else if length(edServidor.Text)<3 then
            TextoMensaje:=MEN_IP_GATEWAY
        else if (leftstr(edvlc.text,7)<>'239.255') or (RightStr(edvlc.text,1)<>'0')then
            TextoMensaje:=MEN_IP_VLC
        else if opAutomatico.Checked then
            begin
                if length(cbonumcol.Text)<1 then
                         TextoMensaje:=MEN_NUMERO_FILAS
                else if length(cbonumord.Text) <1 then
                         TextoMensaje:=MEN_NUMERO_ORDENADORES
            end
         else if todosinvisibles then
               TextoMensaje:=MEN_IPS_INVISBLES;

        for i:=0 to g_num_diseno-1 do
            if length(Trim(edord[i].Text))<2 then
                TextoMensaje:=MEN_IPS_ALUMNOS;
        result:=TextoMensaje='';
        if not result then
                mensaje(TextoMensaje,aceptar);
    end;

procedure TfrmConPro.OrdenadoresCombo(no:integer;cboC:TCombobox);
    var
        i:integer;
    begin
        with cboC do
            begin
                Text:='';
                Clear;
                if no=2 then
                no:=14
                else
                no:=21;
                for i:=1 to no do
                        Items.Add(inttostr(i));
                Enabled:=true;
            end
    end;

procedure TfrmConPro.OcultarOrdenatas;
    var
        i:integer;
    begin
        for i:=low(ordcon) to high(ordcon) do
            begin
                ordcon[i].visible:=false;
                lblOrd[i].visible:=false;
                edord[i].visible:=false;

                end;
    end;

Function TfrmConPro.NumOrdPantalla(Or_Au:integer):integer;
    begin
        case Or_Au of
            0..12: result:=12;
            13..15:result:=15;
            16..18:result:=18;
            else
                result:=21
        end;
    end;

Procedure TfrmConPro.MostrarPersonal();
    var
        i,alto,ancho:integer;
    begin
        OcultarOrdenatas;
        alto:=58;
        ancho:=63;
        for i:=0 to high(OrdCon) do
            OrdCon[i].visible:=false;
        for i:=0 to g_num_diseno-1 do
            begin
                OrdCon[i].SetBounds(f_Posiciones[i].x,f_Posiciones[i].y,ancho,alto);
                if f_Posiciones[i].x>400 then
                begin
                        OrdCon[i].Visible:=true;
                        with lblOrd[i]do
                            begin
                                SetBounds(f_Posiciones[i].x-19,f_Posiciones[i].y+OrdCon[i].Height+1, OrdCon[i].Width +39,18);
                                visible:=true;
                            end;
                        with edord[i]do
                            begin
                                SetBounds(f_Posiciones[i].x-22,f_Posiciones[i].y+OrdCon[i].Height+1,OrdCon[i].Width+45,18);
                            end;
                        with edmac[i]do
                            begin
                                SetBounds(f_Posiciones[i].x-22,f_Posiciones[i].y+OrdCon[i].Height+1,OrdCon[i].Width+45,18);
                            end;
                        with edIP[i]do
                            begin
                                SetBounds(f_Posiciones[i].x-22,f_Posiciones[i].y+OrdCon[i].Height+1,OrdCon[i].Width+45,18);
                            end;
                    end;
            end;
    end;

Procedure TfrmConPro.MostrarOrdenadores(numaula,numpan:integer);
    const
        tor:integer=520;
        wo:integer=66;ho:integer=58;

    var
       lor,sepl,lb,tb,spt,i,numsep,numfilas:integer;
       posi3,posi2,cambioi:integer;
    begin

        OcultarOrdenatas;
        if g_numero_columnas=3 then
        sepl:=150
        else
        sepl:=260;
        application.ProcessMessages;
        if cbodistribucion.text='Izquierda-Derecha' then
            begin
                cambioi:=1;posi3:=480;posi2:=500;
            end
        else
            begin
                cambioi:=-1;posi3:=780;posi2:=760;
            end;
        if g_numero_columnas=3 then
        lor:=posi3
        else
        lor:=posi2;
        numfilas:=(numpan div g_numero_columnas);
        numsep:=numfilas -1;
        spt:=(510-(numfilas*59)) div numsep;
        for i:=numaula-1 downto 0  do
            begin
                tb:= i div g_numero_columnas;tb:= tor-tb*(58+spt);
                lb:= i mod g_numero_columnas;lb:= lor+ cambioi*lb*sepl;
                with ordcon[i] do
                    begin
                       SetBounds(lb,tb,wo,ho);
                       visible:=true;
                    end;
                with lblOrd[i]do
                    begin
                        SetBounds(lb-22,tb+59,wo+45,15);
                        visible:=true;
                    end;
                 with edord[i]do
                    begin
                        SetBounds(lb-22,tb+59,wo+45,15);
                    end;
                 with edmac[i]do
                    begin
                        SetBounds(lb-22,tb+59,wo+45,15);
                    end;
                 with edIP[i]do
                    begin
                        SetBounds(lb-22,tb+59,wo+45,15);
                    end;
            end;
    end;

Procedure TfrmConPro.LeerSetupIni;
    var
        Ordbool:boolean;
        Mifichero:TMemIniFile;
        i:integer;
        N_A:integer;
        nmord:string;
    begin
        Mifichero:= TMemIniFile.create(DIR_SETUP_AULALINEX);
        with Mifichero do
            begin
                g_aula:=ReadString('Aula','Aula','');
                nmord:= ReadString('Aula','Numero Ordenadores','15');
                g_CanonTiempo:=ReadInteger('Canon','Tiempo',20);
                if Trim(nmord)=''then
                 N_A:=12
                 else
                  N_A:=strtoint(nmord) ;
                g_numero_columnas:=strtoint(ReadString('Aula','Numero Filas','3'));
                g_num_diseno:=N_A;
                edprofe.text:=ReadString('Profesor','mesa profesor','');
                edalumno.Text:=ReadString('Profesor','mesa alumno','');
                g_TipoClase:= ReadInteger('TipoClase','Tipo',0);
                chkDesInt.Checked:=Readbool('Internet','Internet desactivado',false);
                chkRatTecIna.Checked:=Readbool('RatonTeclado','RatonTeclado inactivos',false);
                chkCanon.Checked:=(Readbool('Canon','Activo',true));
                cbodistribucion.Text:= ifthen(g_tipoClase = 0 ,'Derecha-Izquierda' ,'Izquierda-Derecha');
                cboinicio.text:= ReadString('TipoClase','Inicio','1');
                edservidor.Text:=ReadString('Servidor','IP','');
                cbonumord.Text:=inttostr(N_A);
                cbonumcol.Text:=inttostr(g_numero_columnas);
                edvlc.text:=ReadString('Vlc','IP','239.255.255.0');
                g_DisenoClase:=ReadInteger('Diseno','Tipo',0);
                cboCanonTiempo.Text:=inttostr(g_CanonTiempo);
                for i:=0 to N_A-1 do
                    begin
                        ordbool:=strtobool(readstring ('Estado','Mesa '+ NumOrdLet(i),'0'));
                        ordcon[i].Down:= not ordbool;
                        if g_DisenoClase>0 then
                        LeerCoordenadas(f_Posiciones[i].x,f_Posiciones[i].y,(ReadString('Diseno','Mesa '+ NumOrdLet(i),'0,0')));
                        lblord[i].Caption:=readstring('Mesas','Mesa '+ NumOrdLet(i),g_aula+NumOrdLet(i));
                        edord[i].Text:= lblord[i].Caption;
                        edMac[i].Text:=readstring('MAC','Mesa '+ NumOrdLet(i),g_aula+NumOrdLet(i));
                        edIP[i].Text:=readstring('IPS','Mesa '+ NumOrdLet(i),g_aula+NumOrdLet(i));
                    end;
                     if g_DisenoClase=0 then
                        MostrarOrdenadores(g_num_diseno,NumOrdPantalla(g_num_diseno))
                     else
                        MostrarPersonal;
            end;
    end;

Procedure TfrmConPro.HallarNombresEquipos();
    var
        inicio,i:integer;
    begin
        inicio:=strtoint(cboinicio.Text)-1;
        for i:=0 to strtoint(cbonumord.Text)-1 do
            begin
                edord[i].Text:=edalumno.Text+NumOrdLet(i+inicio);
                lblord[i].Caption:=edord[i].Text;
            end;
    end;

procedure TfrmConPro.GuardarCambios();
    var
        num_col:string;
    begin
        if cbonumcol.Text='' then
        num_col:='3'
        else
        num_col:=cbonumcol.text;
        equipoProfesor.host:=trim(edprofe.text);
        g_aula:= leftbstr(equipoProfesor.host,4);
        g_alumno:=trim(edalumno.Text);
        g_servidor:=trim(edservidor.Text);
        EscribirSetupIni(num_col);
    end;

procedure TfrmConPro.FormCreate(Sender: TObject);
    begin
        top:=13;left:=(screen.Width-width)div 2;
        edprofe.Text:=equipoProfesor.Host;
        edalumno.Text:=g_host_alumno;
        CrearOrdenadores();
        CrearEtiquetasOr();
        edservidor.Text:=trim(hallardato(IP_GATEWAY));
        cbodistribucion.Text:='Derecha-Izquierda';
        cboinicio.Text:='1';
        cbonumcol.Text:='3';
        g_numero_columnas:=strtoint(cbonumcol.text);
        if  fileexists(DIR_SETUP_AULALINEX) then
            LeerSetupIni();
        if length(cbonumcol.Text)>0 then
             OrdenadoresCombo(strtoint(cbonumcol.Text),cbonumord)
        else
             OrdenadoresCombo(2,cbonumord);
        cbonumord.Text:=inttostr(g_num_diseno);
        cbonumord.Enabled:=false;

    end;

procedure TfrmConPro.opPersonalChange(Sender: TObject);
    begin
        if opPersonal.state=cbchecked then
            begin
                TipoDiseno(1);
                if f_iniciando then
                    TfrmColocar.Create(nil).Showmodal
            end
        else
            begin
                TipoDiseno(0);
            end;
    end;

procedure TfrmConPro.tmrDatos1Timer(Sender: TObject);
    var
        fincontador,activados:Boolean;
        nucrecibidos:integer;
    begin
        inc(fcontador);
        activados:=true;
        fincontador:=false;
        if fcontador>ftiempo then fincontador:=true;
        nucrecibidos:=f_equipohallados;
        If nucrecibidos<53 then activados:=false;
        if (activados or fincontador) then
            begin
                tmrDatos1.enabled:=false;
                fcontador:=0;
                refrescarHostMAC();
            end;
    end;

procedure TfrmConPro.tmrMACTimer(Sender: TObject);
    var
        i:integer;
        fintiempo,activados:Boolean;
    begin
        inc(fcontador);
        activados:=true;
        fintiempo:=false;
        if fcontador>ftiempo then
            begin
                fcontador:=0;
                tmrMAC.enabled:=false;
                fintiempo:=true;
                enabled:=true;
            end;
        for I:=0 TO strtoint(cbonumord.Text)-1 do
            if edMAC[i].text='' then
                activados:=false;
        if (activados or fintiempo) then
            begin
                fcontador:=0;
                tmrMAC.enabled:=false;
                enabled:=true;
            end;
    end;

procedure TfrmConPro.btnAceConClick(Sender: TObject);
    var
        i:integer;
    begin
       if  not (equipoProfesor.UsuarioProfesor='root') then
            begin
                mensaje(MEN_NO_PERMISO,aceptar);
                exit;
            end;
        if sametext(edcontra.Text,CONTRA_PROGRAMA)then
            begin
                for i:=0 to controlcount-1 do
                    begin
                        if not (controls[i] is Tlabel) then
                            begin
                                controls[i].Enabled:=true;
                                controls[i].Cursor:=crhandpoint;
                            end;
                    end;
                btnacecon.Enabled:=false;
                btnacecon.Cursor:=crarrow;
                for i:=low(lblOrd) to high(lblOrd) do
                    begin
                       lblord[i].Enabled:=true;
                       lblord[i].Cursor:=crhandpoint;
                    end;
                tipodiseno(g_DisenoClase);
            end
        else
            begin
                mensaje(MEN_CONTRA_INCORRECTA,aceptar);
                edcontra.SelectAll;
                edcontra.SetFocus;
            end;
        f_ContraCorrecta:= not btnacecon.Enabled;
        f_iniciando:=true;
    end;

procedure TfrmConPro.btnColocarClick(Sender: TObject);
    begin
        TfrmColocar.Create(nil).Showmodal
    end;

procedure TfrmConPro.btnSalirClick(Sender: TObject);
    begin
        close
    end;

procedure TfrmConPro.cboDistribucionChange(Sender: TObject);
    begin
        if opAutomatico.Checked then
            MostrarOrdenadores(g_num_diseno,NumOrdPantalla(g_num_diseno))
        else
            MostrarPersonal;
    end;

procedure TfrmConPro.cboInicioChange(Sender: TObject);
    begin
        HallarNombresEquipos;
    end;

procedure TfrmConPro.cboNMIChange(Sender: TObject);
    begin
        if cboNMI.ItemIndex<0 then exit;
        MostrarDatos(0,cboNMI.ItemIndex);
    end;

procedure TfrmConPro.cboNMIClick(Sender: TObject);
    begin
        if cboNMI.ItemIndex<0 then exit;
        MostrarDatos(f_etiqueta_pulsada,cboNMI.ItemIndex);
    end;

procedure TfrmConPro.MostrarDatos(numequipo,tdatos:integer);
    var
       i:integer;
    begin
        for i:=low(edOrd) to high(edOrd) do
            begin
                edOrd[i].Visible:=false;
                edMac[i].Visible:=false;
                edIP[I].visible:=false;
                case tdatos of
                    0:lblord[i].caption:=edord[i].text;
                    1:lblord[i].caption:=edmac[i].text;
                    2:lblord[i].caption:=edIP[i].text;
                end;
            end;
        case tdatos of
            0:
                begin
                   edOrd[numequipo].Visible:=true;
                   edOrd[numequipo].BringToFront;
                end;
            1:
                begin
                   edMAC[numequipo].Visible:=true;
                   edMAC[numequipo].BringToFront;
                end;
            2:
                begin
                   edIP[numequipo].Visible:=true;
                   edIP[numequipo].BringToFront;
                end;
        end;
    end;

procedure TfrmConPro.cboNumColChange(Sender: TObject);
    begin
        g_numero_columnas:=strtoint(cbonumcol.text);
        OrdenadoresCombo(g_numero_columnas,cbonumord);
        OcultarOrdenatas();
        cboNumOrd.enabled:=true;
        cbonumord.Text:='';
    end;

procedure TfrmConPro.cboNumColClick(Sender: TObject);
    begin
        cboNumOrd.Enabled:=true;
    end;

procedure TfrmConPro.cboNumOrdChange(Sender: TObject);
    begin
        g_num_diseno:=strtoint(cbonumord.Text);
        MostrarOrdenadores(g_num_diseno,NumOrdPantalla(g_num_diseno));
    end;

procedure TfrmConPro.cboNumOrdKeyPress(Sender: TObject; var Key: char);
    begin
        key:=#0;
    end;

procedure TfrmConPro.FormActivate(Sender: TObject);
    begin
        if frmMain.Visible then frmMain.hide;
    end;

procedure TfrmConPro.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        closeaction:=cafree;
    end;

procedure TfrmConPro.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        if mensaje(MEN_SALIR_ADMIN,sino)=2 then
                canclose:=false
        else
            begin
                if f_ContraCorrecta then
                    begin
                        if mensaje(MEN_GUARDAR_CAMBIOS,sino)=1 then
                            begin
                                if not validardatos then
                                    canclose:=false
                                else
                                    begin
                                        try
                                            Guardarcambios;
                                        except
                                            mensaje(MEN_NO_PERMISO,aceptar);
                                            application.Terminate;
                                            exit;
                                        end;
                                        hide;
                                        //Ejecutar(ORD_INICIAR_AULALINEX);
                                        application.ProcessMessages;
                                        application.Terminate;
                                    end
                            end
                        else
                            begin
                                frmMain.show;
                                hide;
                            end;
                    end
                else
                    begin
                        frmMain.show;
                        hide;
                    end;
             end
    end;

procedure TfrmConPro.btiConectarClick(Sender: TObject);
    begin
       if length(cbonumord.Text)<1 then
            begin
                mensaje(MEN_ELIGE_NUM_ORD,aceptar);
                exit;
            end;
        if mensaje(MEN_ORDENADORES_ENCENDIDOS,sino)=2 then exit;
        enabled:=false;
        buscaMAC();
        tmrMAC.enabled:=true;
    end;

procedure TfrmConPro.bitModDNSClick(Sender: TObject);
    begin
        HallarNombresEquipos
    end;

Procedure TfrmConPro.EscribirSetupIni(nf:string);
    var
        xycoor:string;
        Ordbool:boolean;
        Mifichero:TMemIniFile;
        i,b,c,ndisAula:integer;
    begin
        Mifichero:= TMemIniFile.create(DIR_SETUP_AULALINEX);
        try
          try

          if cbodistribucion.text='Derecha-Izquierda' then
              ndisAula:=0
          else
              ndisAula:=1;
          randomize;
          b:=random(255);c:=0;
          if leftstr(trim(edvlc.Text),7)<>'239.255' then
                  g_ipvlc:='239.255'+'.'+inttostr(b)+'.'+inttostr(c)
          else
              g_ipvlc:=edvlc.Text;
          g_CanonActivo:=chkCanon.Checked;
          g_CanonTiempo:=strtoint(cboCanonTiempo.Text);
          g_Internet_defecto:=chkDesInt.Checked;
          g_RatonTecladoDefecto:=chkRatTecIna.Checked;
          if opPersonal.Checked then
              g_DisenoClase:=1
          else
              g_DisenoClase:=0;
          with MIfichero do
              begin
                  WriteString('Aula','Aula',g_aula);
                  WriteString('Aula','Numero Filas',nf);
                  WriteString('Aula','Numero Ordenadores',inttostr(g_num_diseno));
                  WriteString('Profesor','mesa profesor',equipoProfesor.host);
                  WriteString('Profesor','mesa alumno',g_alumno);
                  WriteInteger('TipoClase','Tipo',ndisAula);
                  WriteString('TipoClase','Inicio',cboinicio.text);
                  WriteString('Alumno','alumno','aulalinex');
                  WriteString('Servidor','IP',g_servidor);
                  WriteString('Vlc','IP',g_ipvlc);
                  writebool('Internet','Internet desactivado',g_Internet_defecto);
                  writebool('RatonTeclado','RatonTeclado inactivos',g_RatonTecladoDefecto);
                  WriteInteger('Diseno','Tipo',g_DisenoClase);
                  writebool('Canon','Activo',g_CanonActivo);
                  WriteInteger('Canon','Tiempo',g_CanonTiempo);
                  for i:=0 to g_num_diseno-1 do
                      begin
                          if g_DisenoClase>0 then
                          begin
                          xycoor:=inttostr(f_Posiciones[i].x)+','+inttostr(f_Posiciones[i].y);
                          WriteString ('Diseno','Mesa '+NumOrdLet(i),xycoor);
                          end;
                          ordbool:= not ordcon[i].Down;
                          WriteString ('Mesas','Mesa '+NumOrdLet(i),trim(edord[i].Text));
                          WriteString ('MAC','Mesa '+NumOrdLet(i),trim(edMAC[i].Text));
                          WriteString ('IPS','Mesa '+NumOrdLet(i),trim(edIp[i].Text));
                          WriteString ('Estado','Mesa '+NumOrdLet(i),booltostr(ordbool));
                      end;
                  UpdateFile;
              end;
              Ejecutar('chmod 644 /var/lib/aulalinex-profesor-ltsp/setup.ini')
              except
                  begin
                      Mensaje(MEN_ERROR_GUARDAR_AULA,aceptar);
                      application.Terminate;
                  end;
              end;
          finally
              Mifichero.free;
          end;
    end;

procedure TfrmConPro.buscaMAC;
    var
        i:integer;
    begin
        for i:=0 to strtoint(cbonumord.Text)-1 do
            begin
                OrdCon[i].Down:=false;
                edmac[i].Text:='';
                with ThrMAC.create(i,edord[i].Text)do Resume;
            end;
    end;

procedure TfrmConPro.CrearOrdenadores();
    var
        i:integer;
    begin
        for i:= low(ordcon) to high(ordcon) do
            begin
                ordcon[i]:=TSpeedButton.Create(self);
                with ordcon[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        Visible:=false;
                        imlord.GetBitmap(0,Glyph);
                        NumGlyphs:=4;
                        Enabled:=false;
                        Cursor:=crarrow;
                        Parent:=self;
                        GroupIndex:=i+1;
                        AllowAllUp:=true;
                    end;
            end;
    end;

procedure TfrmConPro.CrearEtiquetasOr();
    var
        i:integer;
    begin
        for i:= low(lblOrd) to high(lblOrd) do
            begin
                lblOrd[i]:=Tlabel.Create(self);
                with lblOrd[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        transparent:=false;
                        autosize:=false;
                        alignment:=tacenter;
                        font.Name:='Sans';
                        font.Size:=9;
                        layout:=tlcenter;
                        Visible:=false;
                        Enabled:=false;
                        caption:=g_host_alumno+NumOrdLet(i);
                        onclick:=@lblordclick;
                        Cursor:=crarrow;
                        Parent:=self;
                    end;
            end;
        for i:= low(edOrd) to high(edOrd) do
            begin
                edOrd[i]:=Tedit.Create(self);
                with edOrd[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        font.Name:='Sans';
                        font.Size:=9;
                        Visible:=false;
                        Enabled:=true;
                        text:=lblOrd[i].Caption;
                        Cursor:=crdefault;
                        OnKeyPress:=@edOrdKeyPress;
                        Parent:=self;
                    end;
                end;
        for i:= low(edMAC) to high(edMAC) do
            begin
                edMAC[i]:=Tedit.Create(self);
                with edMAC[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        font.Name:='Sans';
                        font.Size:=9;
                        Visible:=false;
                        Enabled:=true;
                        text:='00:00:00:00:00';
                        Cursor:=crdefault;
                        OnKeyPress:=@edMACKeyPress;
                        Parent:=self;
                    end;
            end;
        for i:= low(edIP) to high(edIP) do
            begin
                edIP[i]:=Tedit.Create(self);
                with edIP[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        font.Name:='Sans';
                        font.Size:=9;
                        Visible:=false;
                        Enabled:=true;
                        text:='192.168.0.'+inttostr(i+1);
                        Cursor:=crdefault;
                        OnKeyPress:=@edIPKeyPress;
                        Parent:=self;
                    end;
            end;

    end;
procedure TfrmConPro.lblordclick(sender:Tobject);
    begin
        f_etiqueta_pulsada:=(sender as Tlabel).tag;
        if cboNMI.ItemIndex<0 then exit;
        MostrarDatos(f_etiqueta_pulsada,cboNMI.ItemIndex);
    end;

procedure TfrmConPro.edOrdKeyPress(Sender: TObject; var Key: Char);
    begin
        if not(key in['a'..'z','A'..'Z','0'..'9','.','-','_',':',#8]) then
            key:=#0;
    end;

procedure TfrmConPro.edMACKeyPress(Sender: TObject; var Key: Char);
    begin
        if not(key in['0'..'9','a'..'f','A'..'F',':',#8]) then  key:=#0;
    end;

procedure TfrmConPro.edIPKeyPress(Sender: TObject; var Key: Char);
    begin
        if not(key in['0'..'9','.',#8]) then  key:=#0;
    end;

initialization
  {$I configurarpro.lrs}
end.

