{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit examen;

{$mode objfpc}{$H+}

interface

uses IdSync,IdURI,IniFiles,globales,globales1,textomensajes,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, IdCmdTCPServer, Buttons, Math, DbCtrls, IdCommandHandlers, ComCtrls;

type
      TExamenSync = class(TIdSync)
        protected
            fip, frespuestas:string;
	    ftiempo: integer;
            procedure DoSynchronize; override;
        public
            constructor Create(ip,respuestas,tiempo: string);
            class procedure add(ip,respuestas,tiempo: string);
        end;
     Tposiciones=record
        texto:string;
        valor:double;
        color:Tcolor;
       end;
     TExamen=record
        preguntas:array [0..24]of string;
        opciones:array[0..24]of array [0..5] of string;
        soluciones:array [0..24]of integer;
        aciertos:array[0..24]of integer;
        fallos:array [0..24]of integer;
        blancos:array[0..24]of integer;

    end;
  { TfrmExamen }

  TfrmExamen = class(TForm)
    btnCargar: TButton;
    btnEnviar: TButton;
    btnGuardar: TButton;
    btnGuardarN: TButton;
    btnDevolver: TButton;
    btnPreguntas: TButton;
    btnNotas: TButton;
    btnNuevo: TButton;
    btnTerminar: TButton;
    btnSiguiente: TButton;
    btnAnterior: TButton;
    btnSalir: TButton;
    btnIndividual: TButton;
    btnGuardarR: TButton;
    btnMostrar: TButton;
    btnVolver: TButton;
    btnMos: TButton;
    btnAnadir: TButton;
    btnVolverN: TButton;
    cboNumOpc: TComboBox;
    cboNumPreguntas: TComboBox;
    cboTiempo: TComboBox;
    cbocurso: TComboBox;
    cboEvaluacion: TComboBox;
    cboAsignatura: TComboBox;
    ComboBox4: TComboBox;
    DBNavigator1: TDBNavigator;
    dbPregunta: TDBText;
    dbopc3: TDBText;
    dbopc2: TDBText;
    DBText4: TDBText;
    dbopc4: TDBText;
    dbpc1: TDBText;
    Image2: TImage;
    imgGrafico: TImage;
    lblpre: TLabel;
    Label68: TLabel;
    lblMenTiempo: TLabel;
    lblMensaje: TLabel;
    lblNotaM: TLabel;
    lblNumPreguntas: TLabel;
    lblTiempo: TLabel;
    lblNumExaminados: TLabel;
    lblNumEquipos: TLabel;
    lblNumOpciones: TLabel;
    lblSolucion: TLabel;
    lblTiempo2: TLabel;
    lblTitNotaM: TLabel;
    lblTitNotaM1: TLabel;
    lblTitNotaM2: TLabel;
    lbl: TLabel;
    lblTitNotaM4: TLabel;
    lblTitNotaM5: TLabel;
    mePregunta: TEdit;
    edNombreTest: TEdit;
    IdCmdTCPServer1: TIdCmdTCPServer;
    Image1: TImage;
    imgMensaje1: TImage;
    lblAciertosPor: TLabel;
    lblBlancosPor: TLabel;
    lblFallosPor: TLabel;
    lblMensaje2: TLabel;
    lblPregActiva: TLabel;
    meNotas: TMemo;
    OpenDialog1: TOpenDialog;
    pnEstadisticas1: TPanel;
    pnGrafico: TPanel;
    pnGuardarN: TPanel;
    pnquext: TPanel;
    pbTiempo: TProgressBar;
    SaveDialog1: TSaveDialog;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    tmrReloj: TTimer;
    tmrRecogida: TTimer;
    procedure btnAnteriorClick(Sender: TObject);
    procedure btnCargarClick(Sender: TObject);
    procedure btnDevolverClick(Sender: TObject);
    procedure btnEnviarClick(Sender: TObject);
    procedure btnGuardarClick(Sender: TObject);
    procedure btnGuardarNClick(Sender: TObject);
    procedure btnGuardarRClick(Sender: TObject);
    procedure btnIndividualClick(Sender: TObject);
    procedure btnMensaje1Click(Sender: TObject);
    procedure btnMosClick(Sender: TObject);
    procedure btnMostrarClick(Sender: TObject);
    procedure btnNotasClick(Sender: TObject);
    procedure btnNuevoClick(Sender: TObject);
    procedure btnPreguntasClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure btnTerminarClick(Sender: TObject);
    procedure btnVolverNClick(Sender: TObject);
    procedure cbocursoChange(Sender: TObject);
    procedure cboEvaluacionChange(Sender: TObject);
    procedure cboNumOpcChange(Sender: TObject);
    procedure cboNumPreguntasChange(Sender: TObject);
    procedure cboTiempoChange(Sender: TObject);
    procedure edNombreTestKeyPress(Sender: TObject; var Key: char);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure respuestasExamenCommand(ASender: TIdCommand);
    procedure tmrRecogidaTimer(Sender: TObject);
    procedure tmrRelojTimer(Sender: TObject);
  private
    procedure ActivarControlesExamen;
    procedure AlmacenarPregunta(preAct: integer);
    procedure CargarPreguntasQuext(eval: integer);
    procedure ClasificarNotas;
    function CrearArchivoExamen():Boolean;
    procedure CrearMemos;
    procedure DesactivarControles;
    procedure DesactivarControlesExamen;
    procedure DevolverExamen(examen: string);
    procedure DrawPieSlice(myB:  TBitmap; const bcolor,
    pcolor: Tcolor; const Center: TPoint; const Radius: INTEGER;
    const StartDegrees, StopDegrees: Double);
    procedure EncuestaDesmarcarOpciones();
    procedure EncuestaMarcarCorrecta(sol: integer);
    procedure EstadisticaPintarFondo(img: TBitmap; Titulo, base: String);
    procedure EnviarConsulta(nombre: String);
    procedure FinalizarTCPCMD();
    procedure GuardarExamenCorregido(numord: integer);
    procedure GuardarNotas();
    function InicializarConsulta(archivoexamen:string):boolean;
    procedure IndividualMostrarEstadisticas();
    procedure IndividualPintarCabecera(ima: TBitmap);
    procedure IndividualPintalFondo(ima: TBitmap; numalu: integer);
    procedure IndividualPintarResultados(ima: TBitmap);
    procedure IniciarTCPCMD();
    procedure LeerPreguntaExamen(archivo: string);
    procedure LimpiarExamen();
    procedure MostrarAsignaturas();
    procedure MostrarEstadisticasExamen;
    procedure MostrarMemos(preguntaActiva, numOpc: integer);
    procedure NotasMostrarEstadisticas();
    procedure NotasPintarFondo(img: TBitmap);
    procedure NotasPintarResultados(img: TBitmap; notas: array of integer);
    procedure OcultarPaneles();
    procedure OcultarPresenta();
    procedure ordenarClasificacion();
    procedure ResultadosEstadisticas(aci,fal,bla:integer);
    procedure ResultadosPintarLeyendas(ima: TBitmap; ancho, alto: integer;
    leyenda: array of string; colores: array of Tcolor);
    procedure TodosPresentar();
    function ValidarAnadirQuext(): Boolean;
    function ValidarExamen(): Boolean;
    procedure ResultadosPregunta();

    { private declarations }
  public
     procedure anadirRespuesta(ip: string; respuestas: string; tiempo: integer);
    { public declarations }
  end;

var
  frmExamen: TfrmExamen;
  meOpciones:array[0..5] of TEdit;
  lblOpciones:Array[0..5]of Tlabel;
  cboSoluciones:TComboBox;
  f_examen_tipos_notas:Array[0..9] of integer;
  f_pregunta_activa:integer=0;
  f_examen_tiempo:integer=0;
  f_examen_tipo:integer=0;
  f_examen_numero_preguntas:integer=0;
  f_examen_numero_opciones:integer=0;
  f_examen_numero_alumnos_examinados:integer=0;
  f_examen_numero_alumnos_recogido_examen:integer=0;
  f_examen_recoger:boolean=false;
  f_examen_cadena_soluciones:string='';
  f_examen_nota_media:string;
  f_examen_contador:integer=60;

implementation

uses inicio;
var
    g_examen:TExamen;
    indexm:array of integer;
    f_estudiandoDatos:boolean=false;

procedure TfrmExamen.anadirRespuesta(ip: string; respuestas: string; tiempo: integer);
    var
        i:integer;
    begin
        for i:=0 to high(equipoalumno) do
            begin
                if (equipoalumno[i].IP=ip) then
                    begin
                       if (equipoAlumno[i].ExamenHace) then
                             if not equipoAlumno[i].ExamenTerminado then
                                equipoalumno[i].cargarRespuestasExamen(f_examen_cadena_soluciones,respuestas,tiempo);
                    end;
            end;
    end;

procedure TfrmExamen.respuestasExamenCommand(ASender: TIdCommand);
    var
        ip,tiempo,respuestas:string;
    begin
        try
            if ASender.Params.Count=5 then
                begin
                    ip:=TidURI.URLDecode(Asender.Params[0]);
                    respuestas:=TidURI.URLDecode(Asender.Params[2]);
                    tiempo:=TidURI.URLDecode(Asender.Params[3]);
                    TExamenSync.add(ip,respuestas,tiempo)
                end
        except
            writeln(MEN_ORDEN_NUM_INCORRECTOS);
        end;
    end;

procedure TfrmExamen.tmrRecogidaTimer(Sender: TObject);
    var
        i:integer;
        terminado:Boolean;
    begin
        terminado:=true;
        for i:=0 to high(equipoalumno) do
            begin
                  if equipoalumno[i].ExamenHace then
                      if equipoalumno[i].examenTerminado=false then
                          terminado:=false;

            end;
        if terminado or (f_examen_contador<=0) then
           begin
                tmrRecogida.enabled:=false;
                tmrReloj.enabled:=false;
                g_contadorExamen:=0;
                lblMenTiempo.caption:=MEN_CALCULANDO_RESULTADOS;
                for i:=0 to high(equipoalumno) do
                    begin
                          if equipoalumno[i].ExamenHace then
                              if equipoalumno[i].examenTerminado=false then
                                  anadirRespuesta(equipoAlumno[i].ip,'',f_examen_tiempo);

                    end;
                f_examen_contador:=f_examen_tiempo+10;
                MostrarEstadisticasExamen();
                exit;
           end;
        f_examen_contador:=f_examen_contador-1;
   end;

constructor TExamenSync.Create(ip,respuestas,tiempo: string);
    begin
        inherited Create;
        fip:= ip;
        frespuestas:=respuestas;
         try
            ftiempo:=strtoint(tiempo);
        except
            ftiempo:=60
        end
    end;

procedure TExamenSync.DoSynchronize;
    begin
       frmExamen.anadirRespuesta(fip,frespuestas,ftiempo);
    end;

class procedure TExamenSync.add(ip,respuestas,tiempo: string);
    begin
        with Create(ip,respuestas,tiempo) do
        try
            Synchronize;
        finally
            Free;
        end;
    end;

{ TfrmExamen }

procedure TfrmExamen.IniciarTCPCMD();
    begin
        with IdCmdTCPServer1 do
            begin
                Bindings.Clear;
                Bindings.Add;
                Bindings.items[0].IP:='localhost';
                Bindings.Items[0].Port:=PUERTO_PRUEBAS;
                DefaultPort:=PUERTO_PRUEBAS;
                active:=true;
            end;
    end;
procedure TfrmExamen.FinalizarTCPCMD();
    begin
        try
        with IdCmdTCPServer1 do
            begin
                if active then active:=false;
            end;
        except

        end;
    end;

procedure TfrmExamen.EncuestaMarcarCorrecta(sol:integer);
    var
        i:integer;
    begin
        for i:=0 to high(lblOpciones) do
            lblOpciones[i].font.color:=clblack;
        lblOpciones[sol].font.color:=clgreen;
    end;

procedure TfrmExamen.EncuestaDesmarcarOpciones();
    var
        i:integer;
    begin
        for i:=0 to high(lblOpciones) do
            lblOpciones[i].font.color:=clblack;
    end;

procedure TfrmExamen.NotasPintarResultados(img:TBitmap; notas:array of integer);
    const
        ybajo:integer=299;
        anchocolumna:integer=40;
        altofila:integer=10;
        xl:integer=31;
    var
       x0,x1,y0,y1,i:integer;
    begin
        with img.Canvas do
            begin
                for i:=0 to 9 do
                    begin
                        x0:=xl+anchocolumna*i;
                        y0:=ybajo-altofila*notas[i];
                        x1:=x0+anchocolumna;
                        y1:=ybajo;
                        if i<5 then
                            begin
                                pen.Width:=1;
                                pen.Color:=clsilver;
                                brush.color:=ROJO_COLOR;
                            end
                        else
                            begin
                                pen.Width:=1;
                                pen.Color:=clsilver;
                                brush.color:=VERDE_COLOR;
                            end;
                        if notas[i]>0 then
                            Rectangle(x0,y0,x1,y1);
                    end;
            end;
    end;

procedure TfrmExamen.NotasPintarFondo(img:TBitmap);
    const
        yalto:integer=50;
        ybajo:integer=300;
        anchocolumna:integer=40;
        altofila:integer=10;
        xl:integer=30;
        xd:integer=430;
    var
       i:integer;
    begin
        with img.Canvas do
            begin

                for i:=0 to 10 do
                    begin
                        if i=0 then
                            begin
                                pen.Width:=2;
                                pen.Color:=AZUL_COLOR;
                                Pen.Style:=psSolid;
                            end
                        else
                            begin
                                pen.Width:=1;
                                pen.Color:=BLANCO_COLOR;
                                Pen.Style:=psDot;
                            end;

                        Line(xl+anchocolumna*i, yalto,xl+anchocolumna*i, ybajo);
                        Font.Color:=AZUL_COLOR;
                        Font.Name:='Sans';
                        Font.Size:=8;
                        TextOut(xl+anchocolumna*i-3, ybajo+1,inttostr(i));
                    end;
               for i:=0 to 25 do
                    begin
                        if i=25 then
                            begin
                                pen.Width:=2;
                                pen.Color:=AZUL_COLOR;
                                Pen.Style:=psSolid;
                            end
                       else if (i mod 5=0) then
                           begin
                               pen.Width:=1;
                               pen.Color:=AZUL_COLOR;
                               Pen.Style:=psDash;
                               Font.Color:=clblue;
                               Font.Name:='Sans';
                               Font.Size:=8;
                               TextOut(xl-16, yalto-6+altofila*i,inttostr(25-i));
                           end
                        else
                            begin
                                pen.Width:=1;
                                pen.Color:=BLANCO_COLOR;
                                Pen.Style:=psDot;
                            end;
                        Line(xl+1, yalto+altofila*i,xd+1 ,yalto+altofila*i);
                    end;
                    Font.Color:=clblack;
                    brush.color:=VERDE_COLOR;
                    pen.color:=VERDE_COLOR;
                    Rectangle(445,50,455,60);
                    TextOut(458,48,'Aprobados');
                    brush.color:=ROJO_COLOR;
                    pen.color:=ROJO_COLOR;
                    Rectangle(445,65,455,75);
                    TextOut(458,63,'Suspensos');
                    Font.Color:=MORADO_COLOR;
                    TextOut(445,295,'Notas');
                    TextOut(5,30,'Nº Alumnos');
            end;
    end;

procedure TfrmExamen.NotasMostrarEstadisticas();
    var
        mbitmap:TBitmap;
    begin
        mbitmap:=TBitmap.create;
        try
            mbitmap.Width:=imgGrafico.Width;
            mbitmap.Height:=imgGrafico.Height;
            EncuestaDesmarcarOpciones();
            EstadisticaPintarFondo(mbitmap,'','Base');
            NotasPintarFondo(mbitmap);
            NotasPintarResultados(mbitmap,f_examen_tipos_notas);
            imgGrafico.Picture.Bitmap.Assign(mbitmap);
        finally
            mbitmap.free;
        end;
    end;

procedure TfrmExamen.ResultadosPintarLeyendas(ima: TBitmap;ancho,alto:integer; leyenda:array of string; colores:array of Tcolor);
    var
       i:integer;
    begin
        with ima.Canvas do
            begin
                font.Name:='Sans';
                font.size:=9;
                for i:=0 to high(leyenda) do
                    begin
                        brush.color:=colores[i];
                        pen.color:=colores[i];
                        Rectangle(350,35+i*17,365,50+i*17);
                        brush.color:=clBlack;
                        Font.Color:=clBlack;
                        TextOut(367,35+i*17,leyenda[i]);
                    end;
            end;
    end;

procedure TfrmExamen.ResultadosEstadisticas(aci,fal,bla:integer);
     const
         miscolores:array[0..2] of Tcolor=($66FFCC,$7B61FF,$E5E5E5);
         textos:array [0..2] of string =('Aciertos: ', 'Fallos: ', 'NC: ');
    var
        mbitmap:TBitmap;
        i,total,unototal:integer;
        cent:TPoint;
        x0,x1:double;
        xs:array[0..3] of double;
        numopc:array[0..2] of integer;
        numopcp:array[0..2] of double;
        numopcd:array [0..2]of double;
        textoetiquetas:array [0..2] of string;
        colores:array [0..2] of Tcolor;
        pora:string;
    begin
        numopc[0]:=aci;
        numopc[1]:=fal;
        numopc[2]:=bla;
        unototal:=-1;
        mbitmap:=TBitmap.Create;
        try
            mbitmap.Width:=imgGrafico.Width;
            mbitmap.Height:=imgGrafico.Height;
            cent.x:=180; cent.y:=170;
            total:=0;
            for i:=0 to high(numopc)do
                total:=total+numopc[i];
             if total=0 then exit;
            x0:=0;x1:=0; xs[0]:=0;
            EstadisticaPintarFondo(mbitmap,'Opciones','Base');
            EncuestaMarcarCorrecta(g_examen.soluciones[f_pregunta_activa]-1);
            for i:=0 to high(numopc) do
                begin
                    numopcd[i]:=numopc[i]*360/total;
                    numopcp[i]:=numopc[i]*100/total;
                    x0:=x1;
                    x1:=x0+numopcd[i];
                    xs[i+1]:=x1;
                    pora:=FloatToStrF(numopcp[i],ffFixed,8,2);
                    textoetiquetas[i]:= textos[i]+ inttostr(numopc[i])+' -> '+pora +' %';
                    colores[i]:=miscolores[i];
                    if numopc[i]=total then unototal:=i;
                 end;
             ResultadosPintarLeyendas(mbitmap,150,100,textoetiquetas,colores);
             imgGrafico.Picture.Assign(mbitmap);
             if unototal<>-1 then
                 begin
                    imgGrafico.Picture.Bitmap.Canvas.Brush.color:=colores[unototal];
                    imgGrafico.Picture.Bitmap.Canvas.EllipseC(cent.x,cent.y,130,130)
                 end
             else
                 begin
                     for i:=0 to high(numopc) do
                         DrawPieSlice(imgGrafico.Picture.Bitmap,colores[i],clsilver,cent,130,xs[i],xs[i+1]);
                 end;
        finally
            mbitmap.free;
        end;
    end;

procedure TfrmExamen.IndividualMostrarEstadisticas();
    var
        mbitmap:TBitmap;
    begin
        mbitmap:=TBitmap.create;
        try
            mbitmap.Width:=imgGrafico.Width;
            mbitmap.Height:=imgGrafico.Height;
            EncuestaDesmarcarOpciones();
            EstadisticaPintarFondo(mbitmap,'','Base');
            IndividualPintalFondo(mbitmap,10);
            IndividualPintarCabecera(mbitmap);
            IndividualPintarResultados(mbitmap);
            imgGrafico.Picture.Bitmap.Assign(mbitmap);
        finally
            mbitmap.free;
        end;
    end;

Procedure TfrmExamen.EstadisticaPintarFondo(img:TBitmap;Titulo,base:String);
    begin
        with img.Canvas do
            begin
                pen.color:=clsilver;
                brush.color:=clsilver;
                Rectangle(5,0,img.width,img.Height-5);
                pen.color:=clsilver;
                brush.color:=clwhite;
                Rectangle(0,3,img.width-3,img.Height);
                pen.Color:=clBlack;
                Font.Name:='Sans';
                Font.Size:=12;
                TextOut(150,5,Titulo);
             end;
    end;

procedure TfrmExamen.IndividualPintalFondo(ima: TBitmap;numalu:integer);
    const
        colorf:array[0..1] of TColor=(clWhite,$E5E5E5);
        alto:integer=12;
    var
        c,i:integer;
    begin
        with ima.Canvas do
            begin
                for i:=0 to 25 do
                    begin
                        c:=i mod 2;
                        brush.color:=colorf[c];
                        pen.color:=colorf[c];
                        Rectangle(10,12+(alto*i),ima.width-14,12+alto*(i+1));
                    end;
            end;
    end;

Procedure TfrmExamen.IndividualPintarCabecera(ima:TBitmap);
    const
        alto:integer=8;
        posiciones:integer=25;
        separacion:integer=79;
        titulos: array [0..6] of String=('Alumno','Equipo','Nota','Tiempo','Aciertos','Fallos','NC');
    var
        i:integer;
    begin
        with ima.Canvas do
            begin
                Font.Name:='Sanz';
                Font.Size:=9;
                Font.Color:=MORADO_COLOR;
                for i:=0 to high(titulos) do
                    begin
                        brush.color:=clBlack;
                        TextOut(posiciones+separacion*i,alto,titulos[i]);
                    end;
            end;
    end;

Procedure TfrmExamen.IndividualPintarResultados(ima:TBitmap);
    const
        alto:integer=12;
        posiciones:integer=25;
        separacion:integer=79;
    var
        mitiempo:string;
        notas:array of array of string;
        d,j,i:integer;
    begin
        SetLength(notas,g_num_ord_aula);
        with ima.Canvas do
            begin
                Font.Name:='Sanz';
                Font.Size:=8;
                Font.color:=AZUL_COLOR;
                d:=0;
                for i:=0 to high(equipoAlumno) do
                    begin
                       if (equipoAlumno[i].ExamenHace) then
                           begin
                               mitiempo:=tiempo(equipoAlumno[i].ExamenTiempo);
                               SetLength(notas[i],7);
                               notas[i][0]:=equipoAlumno[i].NombreMonitor;
                               notas[i][1]:=equipoAlumno[i].mihost;
                               notas[i][2]:=FloatToStrF(equipoAlumno[i].ExamenNota,ffFixed,8,1);
                               notas[i][3]:=mitiempo;
                               notas[i][4]:=inttostr(equipoAlumno[i].ExamenAciertos);
                               notas[i][5]:=inttostr(equipoAlumno[i].ExamenFallos);
                               notas[i][6]:=inttostr(equipoAlumno[i].ExamenBlancos);
                               if equipoAlumno[i].ExamenNota < 5 then
                                  Font.color:=ROJO_COLOR
                               else
                                 Font.color:=AZUL_COLOR;

                               for j:=0 to 6 do
                                  begin
                                      TextOut(posiciones+separacion*j,24+(alto*d),notas[i][j]);

                                  end;
                              inc(d);
                           end;
                    end;
            end;
    end;

procedure TfrmExamen.DrawPieSlice(myB:  TBitmap; const bcolor, pcolor:Tcolor; CONST Center:  TPoint;  CONST Radius:  INTEGER; CONST StartDegrees, StopDegrees:  Double);
    const
       Offset = 0;
    var
       X1,X2,X3,X4:  INTEGER;
       Y1,Y2,Y3,Y4:  INTEGER;
    begin
        X1 := Center.X - Radius;
        Y1 := Center.Y - Radius;
        X2 := Center.X + Radius;
        Y2 := Center.Y + Radius;
        X3 := Center.X + Round( Radius*COS( DegToRad(Offset+StartDegrees) ) );
        Y3 := Center.y - Round( Radius*SIN( DegToRad(Offset+StartDegrees) ) );
        X4 := Center.X + Round( Radius*COS( DegToRad(Offset+StopDegrees) ) );
        Y4 := Center.y - Round( Radius*SIN( DegToRad(Offset+StopDegrees) ) );
        with myb.Canvas do
           begin
               pen.width:=1;
               Brush.color:=bcolor;
               pen.Color:=pcolor;
               Pie(X1,Y1,  X2,Y2,  X3,Y3,  X4,Y4);
           end;
    end;

procedure TfrmExamen.DesactivarControles;
    var
        i:integer;
    begin
         edNombreTest.Enabled:=false;
         mePregunta.Enabled:=false;
         for i:=0 to 5 do
             meOpciones[i].Enabled:=false;
         cboSoluciones.Enabled:=false;
         btnNuevo.Enabled:=false;
         btnAnterior.Enabled:=false;
         btnSiguiente.Enabled:=false;
         btnCargar.enabled:=false;
         btnGuardar.enabled:=false;
         btnEnviar.enabled:=false;
         cbotiempo.enabled:=false;
         cboNumPreguntas.enabled:=false;
         cboNumOpc.enabled:=false;
         btnNotas.Enabled:=false;
         btnIndividual.Enabled:=false;
         btnGuardarR.Enabled:=false;
         btnPreguntas.Enabled:=false;
         btnMostrar.enabled:=false;

    end;

procedure TfrmExamen.DesactivarControlesExamen;
    var
        i:integer;
    begin
         edNombreTest.Enabled:=false;
         mePregunta.Enabled:=false;
         for i:=0 to 5 do
             meOpciones[i].Enabled:=false;
         cboSoluciones.Enabled:=false;
         btnAnterior.Enabled:=true;
         btnSiguiente.Enabled:=true;
         btnCargar.enabled:=false;
         btnGuardar.enabled:=false;
         btnEnviar.enabled:=false;
         cbotiempo.enabled:=false;
         cboNumPreguntas.enabled:=false;
         cboNumOpc.enabled:=false;
         btnNotas.Enabled:=true;
         btnTerminar.Enabled:=false;
         btnIndividual.Enabled:=true;
         btnGuardarR.Enabled:=true;
         btnPreguntas.Enabled:=true;
         btnMostrar.enabled:=true;
         btnNuevo.enabled:=true;
         btnDevolver.Enabled:=true;
    end;

procedure TfrmExamen.ActivarControlesExamen;
    var
        i:integer;
    begin
         edNombreTest.Enabled:=true;
         mePregunta.Enabled:=true;
         for i:=0 to 5 do
             meOpciones[i].Enabled:=true;
         cboSoluciones.Enabled:=true;
         btnAnterior.Enabled:=true;
         btnSiguiente.Enabled:=true;
         btnCargar.enabled:=true;
         btnGuardar.enabled:=true;
         btnEnviar.enabled:=true;
         cbotiempo.enabled:=true;
         cboNumPreguntas.enabled:=true;
         cboNumOpc.enabled:=true;
         btnNotas.Enabled:=false;
         btnIndividual.Enabled:=false;
         btnGuardarR.Enabled:=false;
         btnPreguntas.enabled:=false;
         btnMostrar.Enabled:=false;
         btnNuevo.Enabled:=false;
         btnDevolver.Enabled:=true;
    end;

procedure TfrmExamen.LimpiarExamen();
    var
        j,i:integer;
    begin
        DesactivarControles();
        ActivarControlesExamen();
        EncuestaDesmarcarOpciones();
        f_estudiandoDatos:=false;
        mePregunta.text:='';
        for i:=0 to 5 do
            meOpciones[i].text:='';
        cboSoluciones.text:='';
        f_examen_numero_preguntas:=strtoint(cboNumPreguntas.text);
        f_examen_numero_opciones:=strtoint(cboNumOpc.text);
        f_examen_tiempo:=strtoint(cboTiempo.text)*60;
        f_pregunta_activa:=0;
        lblPregActiva.Caption:='1';
        for i:=0 to 24 do
            begin
                g_Examen.preguntas[i]:='';
                g_examen.soluciones[i]:=0;
                for j:=0 to 5 do
                    g_Examen.opciones[j][i]:='';
            end;
        MostrarMemos(f_pregunta_activa,f_examen_numero_opciones);
        pngrafico.Visible:=false;
        pbTiempo.visible:=false;
        lblTiempo2.Visible:=false;
    end;

procedure TfrmExamen.ClasificarNotas;
    var
        j,i:integer;
    begin
        for i:=0 to 9 do f_examen_tipos_notas[i]:=0;
        for j:=0 to high(equipoalumno) do
            begin
                 if  equipoalumno[j].ExamenHace then
                     begin
                         for i:=0 to 9 do
                             begin
                                  if equipoalumno[j].ExamenNota=0 then
                                      begin
                                          f_examen_tipos_notas[0]:=f_examen_tipos_notas[0]+1;
                                          break;
                                      end
                                  else if equipoalumno[j].ExamenNota=5 then
                                      begin
                                          f_examen_tipos_notas[5]:=f_examen_tipos_notas[5]+1;
                                          break;
                                      end
                                  else if (equipoalumno[j].ExamenNota>i) and (equipoalumno[j].ExamenNota <= i+1) then
                                      begin
                                          f_examen_tipos_notas[i]:=f_examen_tipos_notas[i]+1;
                                          break;
                                      end;
                             end;
                       end;
            end;
    end;

procedure TfrmExamen.OcultarPaneles();
    begin
        pnGuardarN.visible:=false;
        pnGuardarN.Align:= alClient;
        pnGrafico.visible:=false;
        pnQuext.Visible:=false;
    end;

function TfrmExamen.ValidarExamen():Boolean;
    var
        j,i:integer;
        mens:string;
    begin
        AlmacenarPregunta(f_pregunta_activa);
        mens:='';
        if Trim(edNombreTest.text)='' then
            begin
                mens:=MEN_NOMBRE_EXAMEN;
            end
        else
            begin
                for j:=0 to f_examen_numero_preguntas-1 do
                    begin
                        if g_Examen.soluciones[j] =0 then
                            mens:=MEN_COMPLETA_SOLUCIONES;
                            for  i:=0 to f_examen_numero_opciones -1 do
                                begin
                                    if length(trim(g_Examen.opciones[j][i]))<1 then
                                        begin
                                          mens:=MEN_COMPLETA_OPCIONES;
                                        end
                                end;
                        if length(Trim(g_Examen.preguntas[j]))<1 then
                            mens:=MEN_COMPLETA_PREGUNTAS;
                    end;
            end;
        result:=mens='';
        if not result then
            begin
                 Mensaje(mens,aceptar);
            end;
    end;

function TfrmExamen.ValidarAnadirQuext():Boolean;
    var
        mens:string;
    begin
        mens:='';
        if (cbocurso.itemindex=-1) or (cboevaluacion.itemIndex=-1) or(cboasignatura.text='Asignatura') then
            mens:=MEN_SELECIONA_CURASI;
        result:=mens='';
        if not result then
            mensaje(mens,aceptar);
    end;

Procedure TfrmExamen.TodosPresentar();
    var
        i:integer;
    begin
        IniciarServidorVnc();
        application.ProcessMessages;
        for i:=0 to high(equipoalumno) do
            equipoalumno[i].mostrar()
    end;

procedure TfrmExamen.ResultadosPregunta();
    var
        j,i:integer;
    begin
       for i:=0 to high(equipoalumno) do
            begin
                g_examen.blancos[i]:=0;
                g_examen.Aciertos[i]:=0;
                g_examen.Fallos[i]:=0;
            end;
        for j:=0 to high(equipoalumno) do
            begin
                 if equipoAlumno[j].ExamenHace then
                 begin
                     for i:=0 to f_examen_numero_preguntas -1 do
                        begin
                            if equipoalumno[j].ExamenRespuestas[i]=0 then
                                g_examen.blancos[i]:=g_examen.blancos[i]+1
                            else if equipoalumno[j].ExamenRespuestas[i]= g_Examen.soluciones[i] then
                                g_examen.Aciertos[i]:=g_examen.Aciertos[i]+1
                            else
                                g_examen.Fallos[i]:=g_examen.Fallos[i]+1
                        end;
                 end;

            end;
    end;

procedure TfrmExamen.ordenarClasificacion();
    var
        i,j,k:integer;
        var mejoresn:array of single;
    begin
        setlength(mejoresn,g_num_ord_aula);
        setlength(indexm,g_num_ord_aula);
        for  i:=0 to high(g_num_ord_aula) do
            indexm[i]:=i;
        for  i:=0 to high(equipoalumno) do
            begin
                if equipoAlumno[i].ExamenHace then
                    begin
                        for j:=0 to high(equipoalumno) do
                            begin
                                 if equipoalumno[i].ExamenNota>= mejoresn[j] then
                                     begin
                                            for k:= high(equipoalumno) downto j do
                                                begin
                                                    if k>0 then
                                                    begin
                                                          mejoresn[k]:=mejoresn[k-1];
                                                          indexm[k]:=indexm[k-1];
                                                    end;
                                                end;
                                        indexm[j]:=i;
                                        mejoresn[j]:=equipoalumno[i].ExamenNota;
                                        break;
                                     end;
                            end;
                   end;
            end;
    end;

procedure TfrmExamen.OcultarPresenta();
    begin
        CerrarServidorVnc;
        application.ProcessMessages;
        IniciarServidorVnc();
    end;

procedure TfrmExamen.MostrarMemos(preguntaActiva,numOpc:integer);
    var
        i:integer;
    begin
        mePregunta.text:=TIdURI.URLDecode(g_examen.preguntas[preguntaActiva]);
        for i:=numOpc to high(meopciones) do
           begin
               meOpciones[i].visible:=false;
               lblOpciones[i].visible:=false;
           end;
        for i:=0 to numOpc-1 do
            begin
                meOpciones[i].text:=TIdURI.URLDecode(g_Examen.opciones[preguntaActiva][i]);
                meOpciones[i].visible:=true;
                lblOpciones[i].top:=meOpciones[i].top+3;
                lblOpciones[i].visible:=true;
            end;
        cboSoluciones.clear;
        for i:=0 to numOpc-1 do
           cboSoluciones.items.add(inttostr(i+1));
        cboSoluciones.text:=inttostr(g_examen.soluciones[preguntaActiva]);
        cboSoluciones.top:=meOpciones[numOpc-1].top+ meOpciones[numOpc-1].height +3;
        lblSolucion.top:=cboSoluciones.top+3;
    end;

procedure TfrmExamen.MostrarEstadisticasExamen;
    var
        i:integer;
        snota,notam:double;
        divisor:integer;
    begin
        snota:=0.00;
        for i:=0 to high(equipoalumno) do
                if equipoAlumno[i].ExamenHace then
                        snota:=snota+equipoalumno[i].ExamenNota;
        divisor:=ifthen(f_examen_numero_alumnos_examinados>0,f_examen_numero_alumnos_examinados,1);
        notam:=snota/divisor ;
        f_examen_nota_media:=FloatToStrF(notam,ffFixed,10,2);
        lblNotam.caption:= f_examen_nota_media;
        lblNumEquipos.Caption:=IntToStr(g_num_ord_aula);
        lblNumExaminados .Caption:=IntToStr(f_examen_numero_alumnos_examinados);
        lblNumOpciones.Caption:=IntToStr(f_examen_numero_opciones);
        lblTiempo.Caption:=cboTiempo.text +' min';
        lblNumPreguntas.Caption:=IntToStr(f_examen_numero_preguntas);
         ClasificarNotas();
        ResultadosPregunta();
        application.processmesSages;
        btnTerminar.Enabled:=false;
        DesactivarControlesExamen();
        OcultarPaneles();
        for i:=0 to high(equipoalumno) do
           GuardarExamenCorregido(i);
       btnNotasClick(btnNotas);
       pnEstadisticas1.Visible:=true;
       pnEstadisticas1.BringToFront;
        f_estudiandoDatos:=true;
        application.processmesSages;
    end;

procedure TfrmExamen.MostrarAsignaturas();
  (*  var
        mat,consql:string;  *)
    begin
 (*       if sqla.active then sqla.close;
        if f_evaluacionexamen=3 then
            begin
                consql:='select distinct(ASIGNATURA) from PREGUNTA where CURSO= :nCursoT';
                sqla.CommandText:= consql;
            end
        else
            begin
                consql:='select distinct(ASIGNATURA) from PREGUNTA where CURSO= :nCursoT and EVALUACION= :nEvaluacionT';
                sqla.CommandText:= consql;
                sqla.Params[1].Value:=f_evaluacionexamen;
            end;
        sqla.Params[0].Value:=f_cursoexamen;
        if not sqla.active then sqla.open;
        cboasignatura.clear;
        while not sqla.eof do
            begin
                mat:=MateriaNombre(sqla.fieldvalues['ASIGNATURA']);
                cboAsignatura.items.add(mat);
                sqla.next;
            end;*)
    end;

procedure TfrmExamen.LeerPreguntaExamen(archivo:string);
    var
        Mifichero:TMemIniFile;
        j,i:integer;
    begin
        IF NOT DirectoryExists(equipoProfesor.DirExamenes) THEN
            ForceDirectories(equipoProfesor.DirExamenes);
        Mifichero := TMemIniFile.Create(archivo);
        try
            with Mifichero do
                begin
                    edNombreTest.text:=ReadString('TIPO','Nombre','prueba');
                    f_examen_tipo:=ReadInteger ('TIPO','Tipo',0);
                    f_examen_numero_preguntas:=ReadInteger('TIPO','Numero_Preguntas',10);
                    cboNumPreguntas.text:=inttostr(f_examen_numero_preguntas);
                    f_examen_numero_opciones :=ReadInteger('TIPO','Numero_Opciones',2);
                    cboNumOpc.text:=inttostr(f_examen_numero_opciones);
                    f_examen_tiempo :=ReadInteger('TIPO','Tiempo',180);
                    cboTiempo.text:=inttostr( f_examen_tiempo div 60);
                    For j:=0 to f_examen_numero_preguntas-1 do
                        begin
                            g_Examen.preguntas[j] :=TIdURI.URLDecode(ReadString('PREGUNTA_'+inttostr(j+1),'Pregunta','' ));
                            for i:=0 to f_examen_numero_opciones-1 do
                                begin
                                    g_Examen.opciones[j][i] :=TIdURI.URLDecode(ReadString('PREGUNTA_'+inttostr(j+1),'Opcion_'+inttostr(i+1),'' ));
                                end;
                            g_Examen.soluciones[j]  :=ReadInteger('PREGUNTA_'+inttostr(j+1),'Solucion',0);
                    end;

                end;
            mostrarMemos(f_pregunta_activa,f_examen_numero_opciones);
            application.ProcessMessages;
        finally
            Mifichero.free;
        end;
    end;

Function TfrmExamen.InicializarConsulta(archivoexamen:string):boolean;
    var
        i: integer;
    begin
        result:=true;
        if not FileExists(archivoexamen) then
            begin
                mensaje(MEN_ERROR_ENVIAR_EXAMEN,aceptar);
                result:=false;
                exit;
            end;
        IniciarServidorVnc();
        DesactivarControles();
        ocultarPaneles();
        f_examen_recoger:=true;
        f_examen_numero_alumnos_examinados:=0;
        f_examen_numero_alumnos_recogido_examen:=0;
        f_examen_contador:=f_examen_tiempo+10;
        g_contadorExamen:=f_examen_tiempo;
        g_examinando:=true;
        try
            if IdCmdTCPServer1.Active=false then
                IniciarTCPCMD();
            for i:=0 to high(equipoalumno) do
                begin
                    equipoAlumno[i].RefrescarEncendido();
                    equipoAlumno[i].ExamenHace:=false;
                    equipoAlumno[i].examenTerminado:=false;
                end;
        except
            result:=false;
            DesactivarControlesExamen();
            Mensaje(MEN_ERROR_INICIAR_SERVIDOR,Aceptar);
        end;
    end;

procedure TfrmExamen.GuardarNotas();
    const
        INTRO:STRING='Curso:     Grupo:      Examen:          Fecha: %s';
        RES_DATOS00:STRING='  - Nº Equipos Aula:%s';
        RES_DATOS0:STRING='  - Nº Alumnos examinados:%s';
        RES_DATOS1:STRING='  - Nº Preguntas:%s';
        RES_DATOS2:STRING='  - Nº Opciones:%s';
        RES_DATOS3:STRING='  - Tiempo(min):%s ';
        RES_ALUMNO:STRING='%s%s%s%s%s%s%s';
        var linea,intro1:string;
        nom,equ,nota,aci,fal,bla,tie:string;
        longi,i:integer;
        notamedia:string;
    begin
        meNotas.lines.clear;
        intro1:=FormatdateTime('dddd,d mmmm yyyy',now);
        intro1:=Format(INTRO,[intro1]);
        meNotas.lines.add(intro1);
        meNotas.lines.add(stringofChar('=',60));
        meNotas.lines.add(stringofChar(' ',40));

        meNotas.lines.add('Datos Examen:');
        meNotas.lines.add(stringofChar('-',40));
        linea:=Format(RES_DATOS00,[inttostr(g_num_ord_aula)]);
        meNotas.lines.add(linea);
        linea:=Format(RES_DATOS0,[inttostr(f_examen_numero_alumnos_examinados)]);
        meNotas.lines.add(linea);
        linea:=Format(RES_DATOS1,[inttostr(f_examen_numero_preguntas)]);
        meNotas.lines.add(linea);
        linea:=Format(RES_DATOS2,[inttostr(f_examen_numero_opciones)]);
        meNotas.lines.add(linea);
        linea:=Format(RES_DATOS3,[tiempo(f_examen_tiempo)]);
        meNotas.lines.add(linea);
        meNotas.lines.add(stringofChar(' ',40));
        meNotas.lines.add('Resultados por grupo:');
        meNotas.lines.add(stringofChar('-',40));
        notamedia:='  - Nota Media Examen: ' + lblNotaM.caption;
        meNotas.lines.add(notamedia);
        meNotas.lines.add(stringofChar(' ',40));
        linea:='  - Número de alumnos por nota:';
        meNotas.lines.add(linea);
        for i:=0 to 9 do
            begin
                linea:='  -> '+ inttostr(i)+' - '+ inttostr(i+1)+': '+inttostr(f_examen_tipos_notas[i]) + ' alumnos';
                meNotas.lines.add(linea);
            end;
        meNotas.lines.add(stringofChar(' ',40));
        linea:='  - Resultados por pregunta:';
        meNotas.lines.add(linea);
        for i:=0 to f_examen_numero_preguntas-1 do
            begin
                linea:='    - '+ inttostr(i+1)+'.- '+g_examen.preguntas[i];
                meNotas.lines.add(linea);
                linea:='    - '+ 'Aciertos: '+ inttostr(g_examen.aciertos[i])+' Fallos: '+ inttostr(g_examen.fallos[i]) +' NC: '+ inttostr(g_examen.blancos[i]);
                meNotas.lines.add(linea);
            end;
        meNotas.lines.add(stringofChar(' ',40));
        meNotas.lines.add('Resultados individuales:');
        meNotas.lines.add(stringofChar('-',40));
        meNotas.lines.add('Alumno________Equipo________Nota_____Aciertos_Fallos___NC_______Tiempo');
        meNotas.lines.add(stringofChar(' ',40));
        for i:=0 to high(equipoalumno) do
          begin
              if equipoAlumno[i].ExamenHace then
                  begin
                      longi:=14- length(equipoalumno[i].NombreMonitor);
                      nom:=equipoalumno[i].NombreMonitor+ stringofChar('_',longi);

                      longi:=14 - length(equipoalumno[i].IP);
                      equ:=equipoalumno[i].IP + stringofChar('_',longi);

                      longi:=9 - length(floattostr(equipoalumno[i].ExamenNota));
                      nota:=FloatToStrF(equipoalumno[i].ExamenNota,ffFixed,10,2) + stringofChar('_',longi);

                      longi:=9 - length(inttostr(equipoalumno[i].ExamenAciertos));
                      aci:=inttostr(equipoalumno[i].ExamenAciertos) + stringofChar('_',longi);

                      longi:=9 - length(inttostr(equipoalumno[i].ExamenFallos));
                      fal:=inttostr(equipoalumno[i].ExamenFallos)+ stringofChar('_',longi);
                      longi:=9 - length(inttostr(equipoalumno[i].ExamenBlancos));
                      bla:=inttostr(equipoalumno[i].ExamenBlancos) + stringofChar('_',longi);
                      tie:=tiempo(equipoalumno[i].ExamenTiempo);
                      linea:=Format(RES_ALUMNO,[nom,equ,nota,aci,fal,bla,tie]);
                      meNotas.lines.add(linea);
                  end;
          end;
    end;
procedure TfrmExamen.EnviarConsulta(nombre:String);
    var
        i:integer;
    begin
        equipoProfesor.ArcExamen:=  equipoProfesor.DirExamenes+PathDelim+nombre+'.txt';
        btnTerminar.Enabled:=true;
        if not InicializarConsulta(equipoProfesor.ArcExamen) then exit;
        for  i:=0 to high(equipoalumno) do
        begin
             if equipoalumno[i].usuarioActivo<>'' then
                begin
                     equipoAlumno[i].ExamenHace:=true;
                     inc(f_examen_numero_alumnos_examinados);
                     equipoalumno[i].iniciarExamen();
                end;
       end;
        tmrRecogida.enabled:=true;
        tmrReloj.enabled:=true;
    end;


procedure TfrmExamen.CrearMemos;
    var
        s,i:integer;
    begin
        s:=-1;
        cboSoluciones:=TComboBox.Create(self);
        with cboSoluciones do
            begin
                width:=60;
                font.name:='Sans';
                font.size:=12;
                height:=5;
                Parent:=self;
                left:= 50;
                top:= 96;
            end;
        lblpre.Font.Name:='Sans';
        lblpre.Font.Size:=12;
        lblpre.Font.Color:=AZUL_COLOR;
        lblSolucion.Font.Name:='Sans';
        lblSolucion.Font.Size:=12;
        lblSolucion.Font.Color:=AZUL_COLOR;
        for i:=0 to 5 do
            begin
                meOpciones[i]:=TEdit.Create(self);
                lblOpciones[i]:=Tlabel.Create(self);
                with lblOpciones[i] do
                  begin
                      font.name:='Sans';
                      font.size:=12;
                      font.Color:=AZUL_COLOR;
                      Caption:= ' Opción ' + intToStr(i+1)+': ';
                      autosize:=false;
                      width:=70;
                      transparent:=true;
                      Parent:=self;
                      tag:=i;
                      if (i mod 2)=0 then
                            begin
                                left:= 8;
                                inc(s)
                            end
                        else
                            begin
                                left:=446;
                            end;
                      top:= mePregunta.top + mePregunta.height + 3 +  (s*(3+mePregunta.height));
                  end;
                  with meOpciones[i] do
                      begin
                          font.name:='Sans';
                          font.size:=12;
                          width:=(873- (2*lblOpciones[i].width)) div 2;
                          height:=mePregunta.height;
                          Parent:=self;
                          tag:=i;
                          text:='';
                          if (i mod 2)=0 then
                            begin
                                left:= mePregunta.left;
                            end
                        else
                            begin
                                left:=lblOpciones[i].left+lblOpciones[i].width+2;
                            end;
                        top:= lblOpciones[i].top;
                      end;
            end;
        cbosoluciones.left:=meOpciones[0].left;
        cboSoluciones.top:=meOpciones[5].top+ meOpciones[5].height;
    end;

function TfrmExamen.CrearArchivoExamen():Boolean;
    var
        Mifichero:TMemIniFile;
        j,i:integer;
    begin
        result:=true;
        try
            IF NOT DirectoryExists(equipoProfesor.DirExamenes) THEN
                CreateDir(equipoProfesor.DirExamenes);
            equipoProfesor.ArcExamen:=equipoProfesor.DirExamenes+PathDelim+edNombreTest.text+'.txt';
            AlmacenarPregunta(f_pregunta_activa);
            f_examen_cadena_soluciones:='';
            for j :=0 to f_examen_numero_preguntas -1 do
                begin
                     f_examen_cadena_soluciones:=f_examen_cadena_soluciones+Trim(inttostr(g_Examen.soluciones[j]));
                end;
            Mifichero := TMemIniFile.Create(equipoProfesor.ArcExamen);
              try
                  with Mifichero do
                      begin
                          writeString('TIPO','Nombre',edNombreTest.text);
                          writeInteger ('TIPO','Tipo',f_examen_tipo);
                          WriteInteger('TIPO','Numero_Preguntas',f_examen_numero_preguntas);
                          WriteInteger('TIPO','Numero_Opciones',f_examen_numero_opciones);
                          WriteInteger('TIPO','Tiempo',f_examen_tiempo);
                          For j:=0 to f_examen_numero_preguntas-1 do
                              begin
                              WriteString('PREGUNTA_'+inttostr(j+1),'Pregunta', TIdURI.ParamsEncode(g_Examen.preguntas[j]));
                              for i:=0 to f_examen_numero_opciones-1 do
                                  WriteString('PREGUNTA_'+inttostr(j+1),'Opcion_'+inttostr(i+1), TIdURI.ParamsEncode(g_Examen.opciones[j][i]));
                              writeInteger('PREGUNTA_'+inttostr(j+1),'Solucion',g_Examen.soluciones[j]);
                              end;
                          UpdateFile;
                      end;
                  sleep(100);
                  application.ProcessMessages;
              finally
                  Mifichero.free;
              end;
        except
            result:=false;
            Mensaje(MEN_ERROR_CREAR_EXAMEN,aceptar);
        end;
    end;

procedure TfrmExamen.GuardarExamenCorregido(numord:integer);
    var
        Mifichero:TMemIniFile;
        j,i:integer;
        aci,fal,tie,nota,fecha,examenalu,carpetaexamen:string;
    begin
        try
            if (not equipoAlumno[numord].ExamenHace) or (equipoAlumno[numord].UsuarioActivo='')  then exit;
            nota:=FloatToStrF(equipoalumno[numord].ExamenNota,ffFixed,10,2);
            aci:=inttostr(equipoalumno[numord].ExamenAciertos);
            fal:=inttostr(equipoalumno[numord].ExamenFallos);
            tie:=tiempo(equipoalumno[numord].ExamenTiempo);
            carpetaexamen:=equipoProfesor.DirExaCorregidos+PathDelim+trim(edNombreTest.text);
            if not DirectoryExists(carpetaexamen) then
               ForceDirectories(carpetaexamen);
            examenalu:=carpetaexamen+PathDelim+equipoAlumno[numord].UsuarioActivo+'.txt';
            fecha:=FormatDatetime('dd/mm/yy',Now);
            Mifichero := TMemIniFile.Create(examenalu);
              try
                  with Mifichero do
                      begin
                        writeString('TIPO','Nombre',edNombreTest.text);
                        writeString('TIPO','Corregido','1');
                        writeString('TIPO','Nota',nota);
                        writeString('TIPO','Aciertos',aci);
                        writeString('TIPO','Fallos',fal);
                        writeString('TIPO','Fecha',fecha);
                        writeString('TIPO','TiempoUsado',tie);
                        writeInteger ('TIPO','Tipo',f_examen_tipo);
                        WriteInteger('TIPO','Numero_Preguntas',f_examen_numero_preguntas);
                        WriteInteger('TIPO','Numero_Opciones',f_examen_numero_opciones);
                        WriteInteger('TIPO','Tiempo',f_examen_tiempo);
                        For j:=0 to f_examen_numero_preguntas -1 do
                            begin
                                WriteString('PREGUNTA_'+inttostr(j+1),'Pregunta', TIdURI.ParamsEncode(g_Examen.preguntas[j]));
                                for i:=0 to f_examen_numero_opciones-1 do
                                    WriteString('PREGUNTA_'+inttostr(j+1),'Opcion_'+inttostr(i+1), TIdURI.ParamsEncode(g_Examen.opciones[j][i]));
                                writeInteger('PREGUNTA_'+inttostr(j+1),'Solucion',g_Examen.soluciones[j]);
                                writeInteger('PREGUNTA_'+inttostr(j+1),'Respuesta',equipoAlumno[numord].ExamenRespuestas[j]);
                            end;
                        UpdateFile;
                    end;
                sleep(100);
                application.ProcessMessages;
            finally
                Mifichero.free;
            end;
        except
            Mensaje(MEN_ERROR_CREAR_EXAMEN,aceptar);
        end;
    end;


procedure TfrmExamen.CargarPreguntasQuext(eval:integer);
  (*  var
        sql1,sql2:string; *)
    begin
  (*      if  sqlq.active then sqlq.close;
        if  cds1.active then cds1.close;
        SQL1:='select PREGUNTA, OPCION1, OPCION2, OPCION3, OPCION4, SOLUCION ';
        SQL1:= SQL1 + 'FROM PREGUNTA WHERE CURSO= :pcu and ASIGNATURA= :pas ';
        SQL1:= SQL1 + 'and EVALUACION= :pev';
        SQL2:='select PREGUNTA, OPCION1, OPCION2, OPCION3, OPCION4, SOLUCION ';
        SQL2:= SQL2 + 'FROM PREGUNTA WHERE CURSO= :pcu and ASIGNATURA= :pas ';
        if eval<>3 then
            begin
                sqlq.commandtext:=SQL1;
                sqlq.Params[2].AsInteger:=cboevaluacion.itemindex;;
            end
        else
            begin
                sqlq.commandtext:=SQL2;
            end;
        sqlq.Params[0].AsInteger:= cbocurso.itemindex;
        sqlq.Params[1].Asstring:=NombreMateria(cboAsignatura.text);
        if not sqlq.active then sqlq.open;
        if not cds1.active then cds1.open;*)
    end;

procedure TfrmExamen.tmrRelojTimer(Sender: TObject);
    begin
         g_contadorExamen:=g_contadorExamen-1;
         pbTiempo.Position:=pbTiempo.Position+1;
         lblTiempo2.caption:=Tiempo(g_contadorExamen);
         if g_contadorExamen<=0 then
         begin
           tmrReloj.enabled:=false;
           lblMenTiempo.Caption:=MEN_ORG_RESULTADOS
         end

    end;

procedure TfrmExamen.btnAnteriorClick(Sender: TObject);
    var
        sumando:integer;
    begin
        sumando:=(sender as Tbutton).tag;
        btnAnterior.enabled:=true;
        btnSiguiente.enabled:=true;
        AlmacenarPregunta(f_pregunta_activa);
        f_pregunta_activa:=f_pregunta_activa+sumando;
        if f_pregunta_activa<=0 then
            begin
                btnAnterior.enabled:=false;
                f_pregunta_activa:=0;
            end
        else if  f_pregunta_activa>=f_examen_numero_preguntas-1 then
            begin
                btnsiguiente.enabled:=false;
                f_pregunta_activa:=f_examen_numero_preguntas-1;
            end;
        lblPregActiva.caption:=inttostr(f_pregunta_activa+1);
        MostrarMemos(f_pregunta_activa,f_examen_numero_opciones);
        if f_estudiandoDatos then
           ResultadosEstadisticas(g_Examen.aciertos[f_pregunta_activa],g_Examen.fallos[f_pregunta_activa],g_Examen.blancos[f_pregunta_activa]);
    end;

procedure TfrmExamen.btnCargarClick(Sender: TObject);
    var
        archivo1,archivo:string;
        exte:string;
    begin
        IF NOT DirectoryExists(equipoProfesor.DirExamenes) THEN
           ForceDirectories(equipoProfesor.DirExamenes);
        OpenDialog1.InitialDir := equipoProfesor.DirExamenes;
        if opendialog1.Execute then
            begin
                archivo1:=opendialog1.FileName;
                archivo:=ExtractFilename(archivo1);
                exte:=ExtractFileExt(archivo);
                archivo:=StringReplace(archivo,exte,'',[rfReplaceAll]);
                ednombretest.text:=archivo;
                LeerPreguntaExamen(archivo1)
            end;
    end;

procedure TfrmExamen.AlmacenarPregunta(preAct:integer);
    var
        i:integer;
    begin
        if cboSoluciones.text='' then cboSoluciones.text:='0' ;
        g_Examen.soluciones[preAct]:=strtoint(cboSoluciones.text);
        g_Examen.Preguntas[preAct]:=mePregunta.text;
        for i:=0 to f_examen_numero_opciones-1 do
        g_Examen.opciones[preAct][i]:=meopciones[i].text;
    end;

procedure TfrmExamen.btnDevolverClick(Sender: TObject);
    var
       examen:string;
    begin
       SelectDirectoryDialog1.InitialDir:=equipoProfesor.DirExaCorregidos;
       if SelectDirectoryDialog1.Execute then
         begin
             examen:=ExtractFileName(SelectDirectoryDialog1.filename);
             if mensaje('¿Desea devolver el examen '+ examen + ' corregido?',sino)=1 then
                    DevolverExamen(examen);
         end;

    end;

procedure TfrmExamen.DevolverExamen(examen:string);
    var
        i:integer;
    begin
        for  i:=0 to high(equipoalumno) do
            equipoalumno[i].RefrescarEncendido();
        Application.ProcessMessages;
        for  i:=0 to high(equipoalumno) do
            begin
                if equipoAlumno[i].UsuarioActivo='' then continue;
                equipoProfesor.ArcExamenCorregido:=  equipoProfesor.DirExaCorregidos+PathDelim+examen+PathDelim+equipoalumno[i].UsuarioActivo+'.txt';
                if fileexists(equipoProfesor.ArcExamenCorregido) then
                equipoalumno[i].devolverExamenCorregido();
            end;
    end;

procedure TfrmExamen.btnEnviarClick(Sender: TObject);
    begin
        if validarExamen then
            begin
                Application.ProcessMessages;
                 if not CrearArchivoExamen() then exit;
                EnviarConsulta(edNombreTest.text);
                f_pregunta_activa:=0;
                MostrarMemos(f_pregunta_activa,f_examen_numero_opciones);
                lblPregActiva.caption:=inttostr(f_pregunta_activa+1);
                pbTiempo.Position:=0;
                pbTiempo.Visible:=true;
                pbTiempo.Max:=f_examen_tiempo;
                lblMenTiempo.caption:=MEN_RECOGIENDO_RESPUESTAS;
                lblMenTiempo.visible:=true;
                lblTiempo2.visible:=true;
            end
    end;

procedure TfrmExamen.btnGuardarClick(Sender: TObject);
    begin
      if validarExamen then
         begin
             CrearArchivoExamen;
             Mensaje('El examen '+ edNombreTest.text+' ha sido guardado en la carpeta aulalinex_consultas/examenes de su directorio personal.',aceptar);
         end;
    end;

procedure TfrmExamen.btnGuardarNClick(Sender: TObject);
    begin
        if savedialog1.execute then
            meNotas.lines.savetofile(savedialog1.filename);
    end;

procedure TfrmExamen.btnGuardarRClick(Sender: TObject);
    begin
        GuardarNotas();
        pnGuardarN.align:=alclient;
        pnGuardarN.bringtofront;
        pnGuardarN.visible:=true;
    end;

procedure TfrmExamen.btnIndividualClick(Sender: TObject);
    begin
        IndividualMostrarEstadisticas();
        pnGrafico.Visible:=true;
       lblTiempo2.bringtofront;
       pnEstadisticas1.Visible:=true;
       pnEstadisticas1.BringToFront
    end;

procedure TfrmExamen.btnMensaje1Click(Sender: TObject);
    begin
        frmMain.ExamenActivo();
        frmMain.show();
        Hide;
    end;

procedure TfrmExamen.btnMosClick(Sender: TObject);
    var
        eval:integer;
    begin
        eval:=cboEvaluacion.itemIndex;
        if ValidarAnadirQuext then CargarPreguntasQuext(eval);
    end;

procedure TfrmExamen.btnMostrarClick(Sender: TObject);
    begin
        if btnMostrar.caption='Mostrar' then
           begin
               btnMostrar.caption:='Ocultar';
               TodosPresentar();
           end
        else
           begin
               btnMostrar.caption:='Mostrar';
               OcultarPresenta();
           end;
    end;

procedure TfrmExamen.btnNotasClick(Sender: TObject);
    begin
        NotasMostrarEstadisticas();
        pnGrafico.visible:=true;
    end;

procedure TfrmExamen.btnNuevoClick(Sender: TObject);
    begin
        if mensaje(MEN_NUEVO_EXAMEN,sino)=1 then
            begin
                LimpiarExamen();
                pnEstadisticas1.visible:=false;
            end;
    end;

procedure TfrmExamen.btnPreguntasClick(Sender: TObject);
     begin
        f_pregunta_activa:=0;
        lblPregActiva.Caption:='1';
        ResultadosEstadisticas(g_Examen.aciertos[f_pregunta_activa],g_Examen.fallos[f_pregunta_activa],g_Examen.blancos[f_pregunta_activa]);
        pnGrafico.Visible:=true;
        MostrarMemos(f_pregunta_activa,f_examen_numero_opciones);
        pnEstadisticas1.Visible:=true;
        pnEstadisticas1.BringToFront
    end;

procedure TfrmExamen.btnSalirClick(Sender: TObject);
    begin
        close;
    end;

procedure TfrmExamen.btnTerminarClick(Sender: TObject);
    var
       terminarexamen:string;
       alumnospendientes:string;
    begin
        if (g_contadorExamen>0) and (f_examen_contador>3) then
            begin
               alumnospendientes:=inttostr(f_examen_numero_alumnos_examinados- f_examen_numero_alumnos_recogido_examen);
               terminarexamen:=Format(MEN_TERMINAR_EXAMEN,[alumnospendientes]);
               if (mensaje(terminarexamen,sino)=1) then
                   begin
                        f_examen_contador:=1;
                        FinalizarTCPCMD();
                   end;
            end;
    end;

procedure TfrmExamen.btnVolverNClick(Sender: TObject);
    begin
        pnGuardarN.visible:=false;
    end;

procedure TfrmExamen.cbocursoChange(Sender: TObject);
    begin
       cboEvaluacion.text:='Evaluación';
       cboAsignatura.text:='Asignatura';
    end;

procedure TfrmExamen.cboEvaluacionChange(Sender: TObject);
    begin
       cboEvaluacion.text:='Evaluación';
       cboAsignatura.text:='Asignatura';
    end;

procedure TfrmExamen.cboNumOpcChange(Sender: TObject);
    begin
        f_examen_numero_opciones:=strtoint(cboNumOpc.text);
        mostrarMemos(f_pregunta_activa,f_examen_numero_opciones)
    end;

procedure TfrmExamen.cboNumPreguntasChange(Sender: TObject);
    begin
        f_examen_numero_preguntas:=strtoint(cboNumPreguntas.text);
        if f_pregunta_activa>=f_examen_numero_preguntas then
            begin
                 f_pregunta_activa:=f_examen_numero_preguntas-1;
                 lblPregActiva.caption:=inttostr(f_pregunta_activa+1);
                 btnsiguiente.enabled:=false;
            end;
        mostrarMemos(f_pregunta_activa,f_examen_numero_opciones)
    end;

procedure TfrmExamen.cboTiempoChange(Sender: TObject);
    begin
        f_examen_tiempo:=strtoint(cboTiempo.text)*60;
    end;

procedure TfrmExamen.edNombreTestKeyPress(Sender: TObject; var Key: char);
    begin
        if not(key in['a'..'z','A'..'Z','0'..'9','.','-','_',#8]) then
        key:=#0;
    end;

procedure TfrmExamen.FormActivate(Sender: TObject);
    begin
        if frmMain.Visible then frmMain.hide;
    end;

procedure TfrmExamen.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        try
            FinalizarTCPCMD();
        finally
            CloseAction:=cafree;
        end;
    end;

procedure TfrmExamen.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        if mensaje(MEN_SALIR_ZONA,sino)=2 then
            canclose:=false
        else
            begin
                if g_contadorExamen>0 then
                    begin
                       if Mensaje(MEN_EXAMEN_ABANDONAR,sino)=2 then
                           begin
                               canclose:=false;
                               exit;
                           end;
                    end;
                g_examinando:=false;
                frmMain.show;
                hide;


            end;
    end;

procedure TfrmExamen.FormCreate(Sender: TObject);
    var
        j,i: integer;
    begin
        top:=13;left:=(screen.Width-width) div 2;
        pnGrafico.SetBounds(7,295,882,324);
        pnGrafico.Color:=clWhite;
        f_examen_numero_preguntas:=strtoint(cboNumPreguntas.text);
        f_examen_numero_opciones:=strtoint(cboNumOpc.text);
        f_examen_tiempo:=strtoint(cboTiempo.text)*60;
        f_pregunta_activa:=0;
        f_examen_tipo:=0;
        application.processmessages;
        CrearMemos;
        for i:=0 to 24 do
            begin
                g_Examen.preguntas[i]:='';
                for j:=0 to 5 do g_Examen.opciones[j][i]:='';
            end;
        application.processmessages;
        MostrarMemos(f_pregunta_activa,f_examen_numero_opciones);
        cbosoluciones.Text:='';
        application.processmessages;
        btnAnterior.enabled:=false;
        lblpregActiva.caption:= inttostr(f_pregunta_activa+1);
        ActivarControlesExamen();
    end;

initialization
  {$I examen.lrs}

end.
