unit dialogos;

{$mode objfpc}{$H+}

interface

uses
  global,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TfrmDialogos }

  TfrmDialogos = class(TForm)
    lblMensaje: TLabel;
    spbSi: TButton;
    spbAceptar: TButton;
    spbNo: TButton;
    imgFondo: TImage;
    procedure FormShow(Sender: TObject);
    procedure SpbClick(Sender: TObject);
  private
    { private declarations }
    procedure MostrarBotones(tipo:EDialogos);
  public
    { public declarations }
  end; 

var
  frmDialogos: TfrmDialogos;

implementation

{ TfrmDialogos }
procedure TfrmDialogos.SpbClick(Sender: TObject);
    begin
        tipodialogo.respuesta:=(sender as tbutton).tag;
        hide;
        close;
    end;

procedure TfrmDialogos.FormShow(Sender: TObject);
    begin
        lblmensaje.caption:= tipodialogo.mensaje;
        MostrarBotones(tipodialogo.ClaseDialogo);
    end;

procedure TfrmDialogos.MostrarBotones(tipo:EDialogos);
    begin
        case tipo of
            Aceptar:
                begin
                    spbAceptar.left:=(width-spbAceptar.Width) div 2;
                    spbSi.Visible:=false;
                    spbNo.Visible:=false;
                end;
            SiNo:
                begin
                    spbSi.Visible:=true;
                    spbNo.Visible:=true;
                    spbAceptar.Visible:=false;
                end
        end;

end;

initialization
  {$I dialogos.lrs}


end.

