unit clservidor;

{$mode objfpc}{$H+}

interface

uses
  unix,Classes, SysUtils,IniFiles,process;
type

   { Tservidor }

   Tservidor = class
      private
        fIP:String;
        fMAC:string;
        fHost:string;
        fIPVLC:string;
        function ObtenerMiIp():string;
        function ObtenerMiMAC():string;
      public
        constructor create (archivoini:string='/etc/aulalinex_server.ini');
        property IP:String read fIP;
        property MAC:String read fMAC;
        property Host:String read fHost;
        property IPVLC:String read fIPVLC write fIPVLC;
        procedure ApagarEquipo();
        function ObtenerHost():string;
        procedure Ejecutar(comando: string);
        function HallarDato(Cmd: string): string;
   end;

implementation

function Tservidor.ObtenerHost():string;
    const
         ORD_HOST:string='hostname | cut -f1 -d"."';
    begin
         result:=HallarDato(ORD_HOST);
    end;

procedure Tservidor.Ejecutar (comando:string);
    begin;
          unix.fpSystem(comando);
    end;

function Tservidor.HallarDato(Cmd:string):String;
    var
        file1: TextFile;
        s,t: ansistring;
        n: longint;
        j:integer;
    begin
        j:=0;
        n:=popen(file1, Cmd, 'r');
        if n=-1 then
            begin
                result:='';
              //  writeln('Error al hallar dato');
                Exit;
            end;
        t:='';
        while not eof(file1) do begin
            Readln(File1,s);
            t:=t+s+Chr(10);
            inc(j);
        end;
        pclose(file1);
        result := trim(t);
    end;
constructor Tservidor.create(archivoini:string='/etc/aulalinex_server.ini');
    begin
         inherited create;
          fIP:=ObtenerMiIP();
          fMAC:=ObtenerMiMAC();
          fHost:=ObtenerHost();
    end;

procedure Tservidor.apagarEquipo;
    const
        ORDEN_APAGAR:string='killall -9 ssh;/sbin/poweroff -fp &';
    begin
        Ejecutar(ORDEN_APAGAR);
    end;


function Tservidor.ObtenerMiIp():string;
   var
        mip:string;
    begin
        mip:=trim(HallarDato('echo $LTSP_CLIENT'));
        result:=mip;
    end;
function Tservidor.ObtenerMiMAC():string;
    const
        ORD_MAC:string='/sbin/ifconfig | grep Ethernet |head -1 | tr -s " " | cut -f5 -d" "';
    begin
        result:=Hallardato(ORD_MAC);
    end;

end.


