{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit pantalla;

{$mode objfpc}{$H+}

interface

uses
  IdURI,IniFiles,FileUtil,Math,globales,globales1,textomensajes,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ExtCtrls, Menus, ExtDlgs, Chart, IdCmdTCPServer, IdCommandHandlers,IdSync;

type
    TCuestionSync = class(TIdSync)
      protected
            fip:string;
      	    frespuesta,ftiempo: integer;
          procedure DoSynchronize; override;
      public
          constructor Create(ip,respuesta,tiempo: string);
          class procedure add(ip,respuesta,tiempo: string);
    end;
    Tposiciones=record
      texto:string;
      valor:double;
      color:Tcolor;
    end;

  { TfrmPresenta }

  TfrmPresenta = class(TForm)
    bchOpciones: TBarChart;
    bitPrueba: TSpeedButton;
    btnCerrarCuestion: TButton;
    btnEnviar: TButton;
    btnIndividual: TButton;
    btnOpciones: TButton;
    btnResultados: TButton;
    cboPresenta: TComboBox;
    cboCuestion: TComboBox;
    IdCmdTCPServer1: TIdCmdTCPServer;
    Image1: TImage;
    imgGrafico: TImage;
    imlMenu: TImageList;
    imgPresenta: TImage;
    lbl: TLabel;
    lblBlanco: TLabel;
    lblMenTiempo: TLabel;
    lblNumCorrectas: TLabel;
    lblNumEncuestados: TLabel;
    lblNumEquipos: TLabel;
    lblNumFallos: TLabel;
    lblRaton: TLabel;
    lblTiempo: TLabel;
    lblTiempo2: TLabel;
    lblTitNotaM: TLabel;
    lblTitNotaM1: TLabel;
    lblTitNotaM2: TLabel;
    lblTitNotaM4: TLabel;
    lblTitNotaM5: TLabel;
    mnuSalir: TMenuItem;
    mnug2: TMenuItem;
    mnuCargar: TMenuItem;
    mnuVer: TMenuItem;
    mnuReducir: TMenuItem;
    mnuAmpliar: TMenuItem;
    mnuApagar: TMenuItem;
    mnuDesconectar: TMenuItem;
    mnuMostrar: TMenuItem;
    mnug: TMenuItem;
    mnuSiguiente: TMenuItem;
    mnuAnterior: TMenuItem;
    meTexto: TMemo;
    OpenDialog1: TOpenDialog;
    pnminimizar: TPanel;
    pnEcuesta: TPanel;
    pnEstadisticas1: TPanel;
    pnPintar: TPanel;
    pnPresenta: TPanel;
    pnRaton: TPanel;
    poPantalla: TPopupMenu;
    bitSubLinea: TSpeedButton;
    sdImagen: TSavePictureDialog;
    bitAnterior: TSpeedButton;
    bitPintar: TSpeedButton;
    bitCursor: TSpeedButton;
    bitCerrar: TSpeedButton;
    bitMaximizar: TSpeedButton;
    bitSiguiente: TSpeedButton;
    bitMinimizar: TSpeedButton;
    bitMostrar: TSpeedButton;
    bitOcultar: TSpeedButton;
    bitApagarSalva: TSpeedButton;
    bitNoNavegar: TSpeedButton;
    bitMenos: TSpeedButton;
    bitMas: TSpeedButton;
    bitSonidos: TSpeedButton;
    shaColor: TShape;
    shaGrosor: TShape;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    bitLinea: TSpeedButton;
    bitMano: TSpeedButton;
    bitSubMano: TSpeedButton;
    tmrMensaje: TTimer;
    tmrRecogida: TTimer;
    procedure bitAnteriorClick(Sender: TObject);
    procedure bitApagarSalvaClick(Sender: TObject);
    procedure bitCargarClick(Sender: TObject);
    procedure bitCerrarClick(Sender: TObject);
    procedure bitCursorClick(Sender: TObject);
    procedure bitLineaClick(Sender: TObject);
    procedure bitManoClick(Sender: TObject);
    procedure bitMasClick(Sender: TObject);
    procedure bitMaximizarClick(Sender: TObject);
    procedure bitMenosClick(Sender: TObject);
    procedure bitMostrarClick(Sender: TObject);
    procedure bitNoNavegarClick(Sender: TObject);
    procedure bitOcultarClick(Sender: TObject);
    procedure bitPintarClick(Sender: TObject);
    procedure bitPruebaClick(Sender: TObject);
    procedure bitSiguienteClick(Sender: TObject);
    procedure bitSonidosClick(Sender: TObject);
    procedure bitSubLineaClick(Sender: TObject);
    procedure bitSubManoClick(Sender: TObject);
    procedure btnCerrarCuestionClick(Sender: TObject);
    procedure btnEnviarClick(Sender: TObject);
    procedure btnIndividualClick(Sender: TObject);
    procedure btnOpcionesClick(Sender: TObject);
    procedure btnResultadosClick(Sender: TObject);
    procedure cboCuestionChange(Sender: TObject);
    procedure cboPresentaChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure imgGraficoClick(Sender: TObject);
    procedure imgPresentaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgPresentaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imgPresentaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuAmpliarClick(Sender: TObject);
    procedure mnuAnteriorClick(Sender: TObject);
    procedure mnuApagarClick(Sender: TObject);
    procedure mnuDesconectarClick(Sender: TObject);
    procedure mnuMostrarClick(Sender: TObject);
    procedure mnuReducirClick(Sender: TObject);
    procedure mnuSiguienteClick(Sender: TObject);
    procedure mnuVerClick(Sender: TObject);
    procedure respuestaCuestionCommand(ASender: TIdCommand);
    procedure tmrMensajeTimer(Sender: TObject);
    procedure tmrRecogidaTimer(Sender: TObject);
  private
    procedure ActivarPintar();
    procedure ActivarSub();
    procedure AlumnoRatonNo(nord: integer);
    procedure AlumnoRatonSi(nord: integer);
    procedure ApagarSalva;
    procedure ApagaSonido();
    procedure AulaCanonAbrir;
    procedure AulaCerrarCanon;
    procedure BuscaFicheros(Ruta, Mascara: AnsiString; var Value: TStringList;
      brec: Boolean);
    procedure BuscaFicherosE(Ruta, Mascara: AnsiString; var Value: TStringList;
      brec: Boolean);
    procedure BuscaFicherosEncuesta(Ruta, Mascara: AnsiString;
      var Value: TStringList; brec: Boolean);
    procedure CargarArchivo();
    procedure CargarHtm(sArch: string);
    procedure CargarImagen(sArc: string;tipo:integer);
    procedure CargarTexto(sArc: string);
    procedure CierraSonido();
    procedure ColocarImagen();
    procedure ColocarShape;
    procedure ColorClick(Sender: TObject);
    procedure comprobarClasificacion(nequ: integer);
    procedure CrearArbol();
    procedure CrearDarRaton;
    procedure CrearPintar();
    procedure Deselegir();
    procedure DrawPieSlice(myB: TBitmap; const bcolor, pcolor: Tcolor;
      const Center: TPoint; const Radius: INTEGER; const StartDegrees,
      StopDegrees: Double);
    function EncuestaLeerArchivo(miarchivo: string): boolean;
    procedure EncuestaMarcarCorrecta(sol: integer;ima: TBitmap);
    procedure EncuestaMostrar();
    procedure EncuestaOcultarLabels();
    procedure EncuestaPintarBordeOpciones(img: Tbitmap);
    procedure EncuestaPintarCuadros(ima: TBitmap; numopc: integer);
    procedure EncuestaRecolocarLabels();
    procedure EncuestasCrearLabels();
    procedure EncuestasLabelsOriginal();
    procedure EnviarConsulta(nombre:string);
    procedure EstadisticaPintarFondo(img: TBitmap; Titulo, base: String);
    function InicializarConsulta(archivoexamen: string): boolean;
    procedure MostrarEstadisticasCuestion();
    procedure HacerPintar(amano: boolean);
    procedure HacerSubRayar(amano: boolean);
    function  ImagenConSonido(const sAr: string): boolean;
    procedure IndividualMostrarEstadisticas();
    procedure IndividualPintarCabecera(ima: TBitmap);
    procedure IndividualPintarFondo(ima: TBitmap; numalu: integer);
    procedure IndividualPintarResultados(ima: TBitmap);
    procedure IniciarTCPCMD();
    procedure LineaClick(Sender: TObject);
    procedure MaxiMini(var Maximizandos: boolean);
    procedure OcultarPresenta();
    procedure OpcionesMostrarEstadisticas1(opciones: array of integer);
    procedure OpcionesPintarLeyendas(ima: TBitmap);
    procedure ResultadosEstadisticas(aci, fal, bla: integer);
    procedure ResultadosPintarLeyendas(ima: TBitmap; ancho, alto: integer;
      leyenda: array of string; colores: array of Tcolor);
    procedure ResultadosPregunta();
    procedure spdarratonclick(sender: Tobject);
    procedure TocarParar();
    procedure TocarSonido();
    procedure TodosCerrarNavegador();
    procedure TodosPresentar();
    procedure ZoomImagen();
    { private declarations }
  public
      procedure anadirRespuesta(ip: string; respuesta, tiempor: integer);
          { public declarations }
  end; 

var
    frmPresenta: TfrmPresenta;
    lbllinea:array[1..10] of Tlabel;
    lblColorLin:array[1..10] of Tlabel;
    lblSub:array[1..4] of Tlabel;
    lblColorSub:array[1..4] of Tlabel;
    spDarRaton:Array of TspeedButton;
    lblPregunta:Tlabel;
    lblOpcion:Array[0..5] of Tlabel;
    g_cuestion:Tcuestion;


implementation


{ TfrmPresenta }
uses  dialogos;
const

    ANCHO_IMAGEN:integer=977;
    ALTO_IMAGEN:integer=660;
    COLORES_PINTAR:array[1..10]of TColor=(clblack,clgray,clNavy,clblue,clgreen,clred,clfuchsia,
                            $0000AAFF,clyellow,clwhite);
    COLORES_SUBRAYAR:Array[1..4] of Tcolor=($00FEC0FF,clAqua,$0000E200,clYellow);
    MEN_SALIR:string='¿Desea salir de la presentación?';
   // ORD_TOCAR_SONIDO:string='xmms -p %s &  2>> /dev/null';
   // ORD_APAGAR_SONIDO:string='xmms -s %s &  2>> /dev/null';
   // ORD_TOCAR_PARAR:string='xmms -t &  2>> /dev/null';
  //  ORD_CERRAR_XMMS:string='killall xmms & 2>> /dev/null';
Var
    f_Maximizando:boolean=true;
    f_AmoRaton:integer=-1;
    f_SonidoPresetar:string;
    f_NumeroImagen:integer=0;
        f_xi,f_xf,f_yi,f_yf:integer;
    f_Activado:boolean;
    f_Pintando:boolean;
    f_Zoom:integer=0;
    f_LeftI,f_TopI,f_WidthI,f_HeightI:integer;
    f_Drawing: Boolean;
    f_LastPos: TPoint;
    f_Wratio,f_Hratio:single;
    f_Wreal,f_Hreal:integer;
    f_Mano,bPinchado:boolean;
    f_DarRaton:Array of boolean;
    f_anchoImg:word=1;
    f_altoImg:word=1;
    f_respuestas_recibidas:array of integer;
    f_contador_mensaje:integer;
    f_consulta_enviada:boolean=false;
    f_cuestion_alumnos_examinados:integer=0;
    f_cuestion_contador:integer=30;
constructor TCuestionSync.Create(ip,respuesta,tiempo: string);
    begin
        inherited Create;
        fip:= ip;
        try
            frespuesta:=strtoint(respuesta);
        except
            frespuesta:=0;
        end;
        try
            ftiempo:=strtoint(tiempo);
        except
            ftiempo:=60
        end
    end;

procedure TCuestionSync.DoSynchronize;
    begin
        frmPresenta.anadirRespuesta(fip,frespuesta,ftiempo);
    end;

class procedure TCuestionSync.add(ip,respuesta,tiempo: string);
    begin
        with Create(ip,respuesta,tiempo) do
        try
            Synchronize;
        finally
            Free;
        end;
    end;

procedure TfrmPresenta.respuestaCuestionCommand(ASender: TIdCommand);
    var
        ip,tiempo,respuestas:string;
    begin
        try
            if ASender.Params.Count=5 then
                begin
                    ip:=TidURI.URLDecode(Asender.Params[0]);
                    respuestas:=TidURI.URLDecode(Asender.Params[2]);
                    tiempo:=TidURI.URLDecode(Asender.Params[3]);
                    TCuestionSync.add(ip,respuestas,tiempo)
                end
        except
           // writeln('orden o número de parámetros incorrecto');
        end;
    end;

procedure TfrmPresenta.IniciarTCPCMD();
    begin
        with IdCmdTCPServer1 do
            begin
                Bindings.Clear;
                Bindings.Add;
                Bindings.items[0].IP:='localhost';
                Bindings.Items[0].Port:=PUERTO_PRUEBAS;
                DefaultPort:=PUERTO_PRUEBAS;
                active:=true;
            end;
    end;

procedure TfrmPresenta.DrawPieSlice(myB:  TBitmap; const bcolor, pcolor:Tcolor; CONST Center:  TPoint;  CONST Radius:  INTEGER; CONST StartDegrees, StopDegrees:  Double);
    const
        Offset = 0;
    var
        X1,X2,X3,X4:  INTEGER;
        Y1,Y2,Y3,Y4:  INTEGER;
    begin
        X1 := Center.X - Radius;
        Y1 := Center.Y - Radius;
        X2 := Center.X + Radius;
        Y2 := Center.Y + Radius;
        X3 := Center.X + Round( Radius*COS( DegToRad(Offset+StartDegrees) ) );
        Y3 := Center.y - Round( Radius*SIN( DegToRad(Offset+StartDegrees) ) );
        X4 := Center.X + Round( Radius*COS( DegToRad(Offset+StopDegrees) ) );
        Y4 := Center.y - Round( Radius*SIN( DegToRad(Offset+StopDegrees) ) );
        with myb.Canvas do
            begin
                pen.width:=1;
                Brush.color:=bcolor;
                pen.Color:=pcolor;
                Pie(X1,Y1,  X2,Y2,  X3,Y3,  X4,Y4);
            end;
    end;
Procedure TfrmPresenta.EstadisticaPintarFondo(img:TBitmap;Titulo,base:String);
    begin
        with img.Canvas do
            begin
                pen.color:=clwhite;
                brush.color:=clwhite;
                Rectangle(0,0,img.width,img.Height);
                pen.color:=$E5E5E5;
                brush.color:=$E5E5E5;
                Rectangle(5,0,img.width,img.Height-5);
                pen.color:=clsilver;
                brush.color:=clwhite;
                Rectangle(0,3,img.width-3,img.Height);
                Font.Color:=clBlack;
                Font.Name:='Sans';
                Font.Size:=8;
                TextOut(150,5,Titulo);
             end;
    end;
procedure TfrmPresenta.ResultadosPintarLeyendas(ima: TBitmap;ancho,alto:integer; leyenda:array of string; colores:array of Tcolor);
    var
       i:integer;
    begin
        with ima.Canvas do
            begin
                font.Name:='Sans';
                font.size:=11;
                for i:=0 to high(leyenda) do
                    begin
                        brush.color:=colores[i];
                        pen.color:=colores[i];
                        Rectangle(520,250+i*25,540,270+i*25);
                        brush.color:=clBlack;
                        Font.Color:=clBlack;
                        TextOut(544,250+i*25,leyenda[i]);
                    end;
            end;
    end;

procedure TfrmPresenta.ResultadosEstadisticas(aci,fal,bla:integer);
     const
         miscolores:array[0..2] of Tcolor=($66FFCC,$7B61FF,$E5E5E5);
         textos:array [0..2] of string =('Aciertos: ', 'Fallos: ', 'NC: ');
    var
        mbitmap:TBitmap;
        i,total,unototal:integer;
        cent:TPoint;
        x0,x1:double;
        xs:array[0..3] of double;
        numopc:array[0..2] of integer;
        numopcp:array[0..2] of double;
        numopcd:array [0..2]of double;
        textoetiquetas:array [0..2] of string;
        colores:array [0..2] of Tcolor;
        pora:string;
    begin
        numopc[0]:=aci;
        numopc[1]:=fal;
        numopc[2]:=bla;
        unototal:=-1;
        bchOpciones.Visible:=false;
        EncuestaRecolocarLabels();
        mbitmap:=TBitmap.Create;
        try
        mbitmap.Width:=imgGrafico.Width;
        mbitmap.Height:=imgGrafico.Height;
        cent.x:=380; cent.y:=380;
        total:=0;
        for i:=0 to high(numopc)do
            total:=total+numopc[i];
         if total=0 then exit;
        x0:=0;x1:=0; xs[0]:=0;
        EstadisticaPintarFondo(mbitmap,'','');
        for i:=0 to high(numopc) do
            begin
                numopcd[i]:=numopc[i]*360/total;
                numopcp[i]:=numopc[i]*100/total;
                x0:=x1;
                x1:=x0+numopcd[i];
                xs[i+1]:=x1;
                pora:=FloatToStrF(numopcp[i],ffFixed,8,2);
                textoetiquetas[i]:= textos[i]+ inttostr(numopc[i])+' -> '+pora +' %';
                colores[i]:=miscolores[i];
                if numopc[i]=total then unototal:=i;
             end;
            ResultadosPintarLeyendas(mbitmap,150,100,textoetiquetas,colores);
            EncuestaPintarBordeOpciones(mbitmap);
            EncuestaMarcarCorrecta(g_cuestion.solucion,mbitmap);
            imgGrafico.Picture.Assign(mbitmap);
             if unototal<>-1 then
                 begin
                      imgGrafico.Picture.Bitmap.Canvas.Brush.color:=colores[unototal];
                      imgGrafico.Picture.Bitmap.Canvas.EllipseC(cent.x,cent.y,150,150)
                 end
             else
                 begin
                 for i:=0 to high(numopc) do
                     DrawPieSlice(imgGrafico.Picture.Bitmap,colores[i],clsilver,cent,150,xs[i],xs[i+1]);
                 end;
             finally
                 mbitmap.free;
             end;
    end;

Procedure TfrmPresenta.IndividualPintarResultados(ima:TBitmap);
    const
        alto:integer=14;
        posiciones:integer=75;
        separacion:integer=200;
    var
       sep,j,i:integer;
       notas:array of array of string;
    begin
        SetLength(notas,f_cuestion_alumnos_examinados);
        for i:=0 to f_cuestion_alumnos_examinados-1 do
            begin
                  SetLength(notas[i],4);
                  notas[i][0]:=g_cuestion.mejoresalumnos[i];
                  notas[i][1]:=g_cuestion.mejoresequipos[i];
                  notas[i][2]:=inttostr(g_cuestion.mejoresrespuestas[i]);
                  notas[i][3]:=inttostr(g_cuestion.mejorestiempos[i]) +' s';
            end;
        with ima.Canvas do
            begin
                Font.Name:='Sans';
                Font.Size:=8;
                Font.color:=AZUL_COLOR;
                sep:=separacion;
                  for i:=0 to high(notas) do
                    begin
                        if notas[i][0]='' then continue;
                        for j:=0 to 3 do
                            begin
                              if notas[i][2]='NC' then
                               Font.color:=clred
                              else if strtoint(notas[i][2])=g_cuestion.solucion then
                                 Font.color:=clgreen
                              else
                                Font.color:=clred;
                             if j=2 then
                                sep:= separacion+15
                             else if j=3 then
                                sep:=separacion+10
                             else
                                 sep:=separacion;
                                if notas[i][2]= '0' then notas[i][2]:='NC';
                                TextOut(posiciones+sep*j,29+(alto*i),notas[i][j]);
                            end;
                    end;
            end;
    end;

Procedure TfrmPresenta.IndividualPintarCabecera(ima:TBitmap);
    const
        alto:integer=12;
        posiciones:integer=75;
        separacion:integer=200;
        titulos: array [0..3] of String=('Alumno','Equipo','Opción','Tiempo');
    var
       i:integer;
    begin
        with ima.Canvas do
            begin
                Font.Name:='Sanz';
                Font.Size:=12;
                Font.Color:=MORADO_COLOR;
                for i:=0 to high(titulos) do
                    begin
                        brush.color:=clBlack;

                        TextOut(posiciones+separacion*i,alto,titulos[i]);
                    end;
            end;
    end;

procedure TfrmPresenta.IndividualPintarFondo(ima: TBitmap;numalu:integer);
    const
        colorf:array[0..1] of TColor=(clWhite,$E5E5E5);
        alto:integer=14;
    var
        c,i:integer;
    begin
        with ima.Canvas do
            begin
                for i:=0 to 36 do
                    begin
                        c:=i mod 2;
                        brush.color:=colorf[c];
                        pen.color:=colorf[c];
                        Rectangle(50,25+(alto*i),ima.width-50,25+alto*(i+1));
                    end;
            end;
    end;

procedure TfrmPresenta.IndividualMostrarEstadisticas();
    var
        mbitmap:TBitmap;
    begin
        mbitmap:=TBitmap.create;
        try
            bchOpciones.Visible:=false;
            EncuestaOcultarLabels;
            mbitmap.Width:=imgGrafico.Width;
            mbitmap.Height:=imgGrafico.Height;
            EstadisticaPintarFondo(mbitmap,'','');
            IndividualPintarFondo(mbitmap,10);
            IndividualPintarCabecera(mbitmap);
            IndividualPintarResultados(mbitmap);
            imgGrafico.Picture.Bitmap.Assign(mbitmap);
        finally
            mbitmap.free;
        end;
    end;

procedure TfrmPresenta.EncuestaMarcarCorrecta(sol:integer;ima: TBitmap);
    var
        lf,tp,bd,hd:integer;
    begin
        lf:=lblopcion[sol-1].left-imggrafico.left-2;
        tp:=lblopcion[sol-1].top-imggrafico.top-1;
        bd:=lf+lblopcion[sol-1].Width+8;
        hd:=tp+lblopcion[sol-1].Height;
        with ima do
            begin
                canvas.Brush.color:=VERDE_COLOR;
                Canvas.Rectangle(lf,tp,bd,hd);
            end;
    end;

procedure TfrmPresenta.EncuestaOcultarLabels();
    var
        i:integer;
    begin
        for i:=0 to high(lblOpcion) do
            lblOpcion[i].visible:=false;
        lblPregunta.visible:=false;
    end;

procedure TfrmPresenta.EncuestaRecolocarLabels();
    var
        s,lf,i:integer;
        x0,y0,x1,y1:integer;
    begin
        lblPregunta.font.name:='Sans';
        lblPregunta.Font.Size:=9;
        lblPregunta.SetBounds(imgGrafico.Left+20,imggrafico.top+14,780,40);
        lblpregunta.BringToFront;
        lblPregunta.visible:=true;
        s:=0;
         for i:=0 to high(lblOpcion)do
         begin
            if i mod 2=0 then
                begin
                    lf:=imgGrafico.Left+40;
                    s:=s+1;
                end
            else
                begin
                   lf:=imgGrafico.Left+437;
                end;
            x0:=lf;
            y0:=lblpregunta.top+lblpregunta.Height+10+(lblpregunta.height +10)*(s-1);
            x1:=357;
            y1:=40;
            lblOpcion[i].font.name:='Sans';
            lblOpcion[i].Font.Size:=9;
            lblOpcion[i].Transparent:=true;
            lblOpcion[i].SetBounds(x0,y0,x1,y1);
            lblOpcion[i].visible:=false;
        end;
        if g_cuestion.numOpciones>0 then
           for i:=0 to g_cuestion.numOpciones -1 do
               lblOpcion[i].visible:=true;
    end;

procedure TfrmPresenta.EncuestaPintarBordeOpciones(img:Tbitmap);
    var
        i:integer;
        lf,tp,bd,hd:integer;
    begin
         with img.canvas do
            begin
            pen.Width:=1;
            pen.Color:=clsilver;
            brush.color:=clwhite;
            lf:=lblpregunta.left-imggrafico.left-2;
            tp:=lblpregunta.top-imggrafico.top-1;
            bd:=lf+lblPregunta.Width+2;
            hd:=tp+lblPregunta.Height+2;
            Rectangle(lf,tp,bd,hd);
            font.Name:='Sans';
            font.Size:=12;
            for i:=0 to g_cuestion.numOpciones-1 do
                begin
                    lf:=lblopcion[i].left-imggrafico.left-2;
                    tp:=lblopcion[i].top-imggrafico.top-1;
                    bd:=lf+lblopcion[i].Width+8;
                    hd:=tp+lblopcion[i].Height;
                    Rectangle(lf,tp,bd,hd);
                    TextOut(lf-15,tp+10,inttostr(i+1));
                end;
            end;
    end;

procedure TfrmPresenta.ResultadosPregunta();
    var
        i:integer;
    begin
        g_cuestion.numaciertos:=0;
        g_cuestion.numfallos:=0;
        g_cuestion.numblancos:=0;
        for i:=0 to High(g_cuestion.mejoresalumnos) do
            g_cuestion.mejorestiempos[i]:=g_cuestion.tiempo+1;
        for i:=0 to high(equipoalumno) do
            begin
                if equipoalumno[i].CuestionHace then
                    begin;
                        if equipoalumno[i].CuestionResultado= 0 then
                            begin
                                inc(g_cuestion.numblancos)
                            end
                        else if equipoalumno[i].CuestionResultado =1 then
                            begin
                                inc(g_cuestion.numaciertos);
                            end
                        else
                            begin
                                inc(g_cuestion.numfallos);
                            end;
                         comprobarClasificacion(i);
                     end;
            end;
    end;

procedure TfrmPresenta.MostrarEstadisticasCuestion();
    begin
        lblMenTiempo.Visible:=False;
        lblTiempo2.visible:=false;
        ResultadosPregunta();
        lblNumEquipos.Caption:=inttostr(g_num_ord_aula);
        lblNumEncuestados.caption:=IntToStr(f_cuestion_alumnos_examinados);
        lblTiempo.Caption:=inttostr(g_cuestion.tiempo) + ' s';
        lblNumCorrectas.Caption:=IntToStr(g_cuestion.numAciertos);
        lblNumFallos.Caption:=IntToStr(g_cuestion.numfallos);
        lblBlanco.Caption:=IntToStr(g_cuestion.numBlancos);
        btnIndividual.Enabled:=true;
        btnOpciones.Enabled:=true;
        btnResultados.Enabled:=true;
        btnOpcionesClick(btnOpciones);
        f_consulta_enviada:=false;
        pnEstadisticas1.BringToFront;
        pnEstadisticas1.visible:=true;
    end;

function TfrmPresenta.EncuestaLeerArchivo(miarchivo:string):boolean;
    var
        Mifichero:TMemIniFile;
        i:integer;
    begin
        result:=true;
        try
          Mifichero := TMemIniFile.Create(miarchivo);
            try
                with Mifichero do
                    begin
                        g_cuestion.numOpciones:= ReadInteger('TIPO','Numero_Opciones',4);
                        g_cuestion.tiempo:=ReadInteger('TIPO','Tiempo',30);
                        g_cuestion.pregunta:=ReadString('CUESTION','Pregunta','');
                        g_cuestion.pregunta:=TIdURI.URLDecode(g_cuestion.pregunta);
                        g_cuestion.solucion:=ReadInteger('TIPO','Solucion',1);
                        lblPregunta.caption:=g_cuestion.pregunta;
                        lblpregunta.Visible:=true;
                        for i:=0 to 5 do
                            lblOpcion[i].visible:=false;
                         for i:=0 to g_cuestion.numOpciones-1 do
                            begin
                                g_cuestion.opciones[i]:=ReadString('CUESTION','Opcion_'+inttostr(i+1),'');
                                g_cuestion.opciones[i]:=TIdURI.URLDecode(g_cuestion.opciones[i]);
                                lblOpcion[i].caption:=g_cuestion.opciones[i];
                                lblOpcion[i].visible:=true;
                              end;
                    end;
                application.ProcessMessages;
            finally
                Mifichero.free;
            end;
        except
            Mensaje(MEN_ERROR_LEER_CUETION,Aceptar);
            result:=false;
        end;
    end;

procedure TfrmPresenta.BuscaFicherosE(Ruta, Mascara : AnsiString; var Value : TStringList; brec : Boolean);
    var
        srBuscar : TSearchRec;
        iEncontrado : Integer;
    begin
        if Ruta[Length(Ruta)] <> '/' then Ruta := Ruta +'/';
        iEncontrado := FindFirst(Ruta+Mascara, faAnyFile-faDirectory, srBuscar);
        while iEncontrado = 0 do
            begin
                if ( srBuscar.Name <> '.' ) and ( srBuscar.Name <> '..' ) and ( srBuscar.Name <> '' ) then
                    Value.Add(ExtractFileNameOnly(srBuscar.Name));
                iEncontrado := FindNext(srBuscar);
            end;
        FindClose(srBuscar);
    end;

procedure TfrmPresenta.EncuestasLabelsOriginal();
    const
        arriba:integer=40;
        altocuestion:integer=60;
    var
        izquierdo,ancho,i:integer;
    begin
        ancho:=imgGrafico.width -60;
        izquierdo:=30;
         with lblPregunta do
            begin
                font.name:='Sans';
                font.size:=11;
                width:=ancho-8;
                height:=62;
                autosize:=false;
                color:=clwhite;
                WordWrap:=true;
                Caption:='';
                transparent:=true;
                left:= imgGrafico.left+izquierdo+4;
                top:=imgGrafico.top + arriba+4;
                visible:=false;
            end;
        for i:=0 to 5 do
            begin
              with lblOpcion[i] do
                    begin
                        font.name:='Sans';
                        font.size:=11;
                        width:=ancho-50;
                        height:=42;
                        autosize:=false;
                        color:=clwhite;
                        WordWrap:=true;
                        Caption:='';
                        tag:=i;
                        left:= imgGrafico.left+74;
                        top:=imgGrafico.top+119+altocuestion*i;
                        visible:=false;
                    end;
            end;
      end;

procedure TfrmPresenta.EncuestasCrearLabels();
    const
        arriba:integer=40;
        altocuestion:integer=60;
    var
        izquierdo,ancho,i:integer;
    begin
        ancho:=imgGrafico.width -60;
        izquierdo:=30;
        lblPregunta:=Tlabel.create(self);
         with lblPregunta do
            begin
                font.name:='Sans';
                font.size:=11;
                width:=ancho-8;
                height:=62;
                autosize:=false;
                color:=clwhite;
                WordWrap:=true;
                Caption:='';
                transparent:=true;
                Parent:=pnEcuesta;
                left:= imgGrafico.left+izquierdo+4;
                top:=imgGrafico.top + arriba+4;
                visible:=false;
            end;
        for i:=0 to 5 do
            begin
              lblOpcion[i]:=Tlabel.create(self);
              with lblOpcion[i] do
                    begin
                        font.name:='Sans';
                        font.size:=11;
                        width:=ancho-50;
                        height:=42;
                        autosize:=false;
                        color:=clwhite;
                        WordWrap:=true;
                        Caption:='';
                        transparent:=true;
                        Parent:=pnEcuesta;
                        tag:=i;
                        left:= imgGrafico.left+74;
                        top:=imgGrafico.top+119+altocuestion*i;
                        visible:=false;
                    end;
            end;
      end;

procedure TfrmPresenta.EncuestaPintarCuadros(ima: TBitmap;numopc:integer);
    const
        arriba:integer=40;
        alto:integer=70;
        altocuestion:integer=60;
    var
        izquierdo,ancho,i:integer;
    begin
        ancho:=imgGrafico.width -60;
        izquierdo:=30;
        with ima.Canvas do
            begin
                Font.Color:=MORADO_COLOR;
                Font.Name:='Sans';
                Font.Size:=12;
                pen.color:=AZUL_COLOR;
                brush.color:=clwhite;
                pen.Width:=1;
                Rectangle(izquierdo,arriba,izquierdo+ancho, arriba+alto);
                TextOut(izquierdo, arriba-18, 'Pregunta');
                for i:=0 to numopc-1 do
                    begin
                        EllipseC(izquierdo+15,140 +altocuestion*i,15,15);
                        TextOut(izquierdo+10,132 +altocuestion*i,inttostr(i+1));
                        Rectangle(izquierdo+40,115+altocuestion*i,izquierdo+ancho,165+altocuestion*i);

                    end;
            end;
    end;

procedure TfrmPresenta.EncuestaMostrar();
    var
        mbitmap:TBitmap;
    begin
        mbitmap:=TBitmap.create;
        try
            mbitmap.Width:=imgGrafico.Width;
            mbitmap.Height:=imgGrafico.Height;
            EstadisticaPintarFondo(mbitmap,'','Base');
            EncuestaPintarCuadros(mbitmap,g_cuestion.numOpciones);
            imgGrafico.Picture.Bitmap.Assign(mbitmap);
            pnEcuesta.BringToFront;
        finally
            mbitmap.free;
        end;
    end;

Function TfrmPresenta.InicializarConsulta(archivoexamen:string):boolean;
    var
        i: integer;
    begin
        result:=true;
        if not FileExists(archivoexamen) then
            begin
                mensaje(MEN_EXAMEN_NO_ENVIADO,aceptar);
                result:=false;
                exit;
            end;
        for i:=0 to high(equipoalumno) do
            equipoAlumno[i].RefrescarEncendido();
        for i:=0 to high( g_cuestion.mejoresalumnos) do
            begin
                g_cuestion.mejoresalumnos[i]:='';
                g_cuestion.mejoresequipos[i]:='';
                g_cuestion.mejorestiempos[i]:=999;
                g_cuestion.mejoresrespuestas[i]:=-1
            end;
        btnEnviar.enabled:=false;
        f_cuestion_alumnos_examinados:=0;
        f_consulta_enviada:=true;
        f_cuestion_contador:=g_cuestion.tiempo+5;
        f_contador_mensaje:=g_cuestion.tiempo;
        setlength(f_respuestas_recibidas, g_cuestion.numOpciones+1);
        for i:=0 to high(f_respuestas_recibidas) do
            f_respuestas_recibidas[i]:=0;
        try
            if IdCmdTCPServer1.Active=false then
                IniciarTCPCMD();

        except
            result:=false;
            Mensaje(MEN_ERROR_INICIAR_SERVIDOR,Aceptar);
        end;
    end;
procedure TfrmPresenta.EnviarConsulta(nombre:string);
    var
        i:integer;
    begin
        equipoProfesor.ArcCuestion:=  equipoProfesor.DirCuestiones+PathDelim+nombre+'.txt';
        if not InicializarConsulta(equipoProfesor.ArcCuestion) then exit;
        for  i:=0 to high(equipoalumno) do
            begin
                  equipoAlumno[i].CuestionHace:=false;
                  equipoAlumno[i].CuestionTerminada:=false;
                 if equipoalumno[i].usuarioActivo<>'' then
                    begin
                         equipoAlumno[i].CuestionHace:=true;
                         inc(f_cuestion_alumnos_examinados);
                         equipoalumno[i].iniciarCuestion();
                    end;
            end;
        tmrRecogida.enabled:=true;
        tmrMensaje.Enabled:=true;
        lblMenTiempo.visible:=true;
        lblTiempo2.visible:=true;
        cboCuestion.Enabled:=false;
        bitPrueba.Enabled:=false;
    end;

procedure TfrmPresenta.OpcionesPintarLeyendas(ima: TBitmap);
    const
         textos:array [0..1] of string=('Correcta','Incorrectas');
    var
       i:integer;
       colores:array [0..1] of TColor;
    begin
        colores[0]:=VERDE_COLOR;
        colores[1]:=ROJO_COLOR;
        with ima.Canvas do
            begin
                font.Name:='Sans';
                font.size:=9;
                for i:=0 to 1 do
                    begin
                        brush.color:=colores[i];
                        pen.color:=colores[i];
                        Rectangle(685,250+i*17,700,265+i*17);
                        brush.color:=clBlack;
                        Font.Color:=clBlack;
                        TextOut(702,250+i*17,textos[i]);
                    end;
            end;
    end;

procedure TfrmPresenta.OpcionesMostrarEstadisticas1( opciones:array of integer);
    var
        mcolor:TColor;
        nombre:string;
        i:integer;
        mbitmap:TBitmap;
    begin
        mbitmap:=TBitmap.create;
        EncuestaRecolocarLabels();
        try
            mbitmap.Width:=imgGrafico.Width;
            mbitmap.Height:=imgGrafico.Height;
            EstadisticaPintarFondo(mbitmap,'','');
            OpcionesPintarLeyendas(mbitmap);
            EncuestaPintarBordeOpciones(mbitmap);
            EncuestaMarcarCorrecta(g_cuestion.solucion,mbitmap);
            imgGrafico.Picture.Bitmap.Assign(mbitmap);
        finally
            mbitmap.free;
        end;
        imgGrafico.visible:=true;
        bchOpciones.clear;
        for i:=0 to high(opciones) do
            begin
                if i<>g_cuestion.solucion then
                    begin
                        mcolor:=ROJO_COLOR;
                    end
                else
                    begin
                        mcolor:=VERDE_COLOR;
                    end;
              if i=0 then nombre:='  NS/NC' else nombre:='Opción ' + inttostr(i);
                bchOpciones.AddBar(nombre,opciones[i],mcolor);
            end;
        bchOpciones.visible:=true;
    end;

procedure TfrmPresenta.comprobarClasificacion(nequ:integer);
    var
        j,k:integer;
    begin
        for j:=0 to high(equipoalumno) do
            begin
                 if equipoAlumno[nequ].CuestionHace then
                 begin
                     if equipoalumno[nequ].CuestionTiempo<= g_cuestion.mejorestiempos[j] then
                         begin
                            for k:=j to high(equipoalumno) do
                                begin
                                  if k<high(equipoalumno) then
                                      begin
                                          g_cuestion.mejoresalumnos[k+1]:=g_cuestion.mejoresalumnos[k];
                                          g_cuestion.mejorestiempos[k+1]:=g_cuestion.mejorestiempos[k];
                                          g_cuestion.mejoresequipos[k+1]:=g_cuestion.mejoresequipos[k];
                                          g_cuestion.mejoresrespuestas[k+1]:=g_cuestion.mejoresrespuestas[k]
                                      end;
                                end;
                            g_cuestion.mejoresalumnos[j]:=equipoalumno[nequ].NombreMonitor;
                            g_cuestion.mejoresequipos[j]:=equipoalumno[nequ].mihost;
                            g_cuestion.mejorestiempos[j]:=equipoalumno[nequ].CuestionTiempo;
                            g_cuestion.mejoresrespuestas[j]:=equipoAlumno[nequ].CuestionRespuesta;
                            break;
                     end;
                  end;
            end;
    end;

procedure TfrmPresenta.anadirRespuesta(ip:string;respuesta,tiempor:integer);
    var
        i:integer;
    begin
        f_respuestas_recibidas[respuesta]:=f_respuestas_recibidas[respuesta]+1;
        for i:=0 to high(equipoalumno) do
            begin
                if (equipoalumno[i].IP=ip) then
                    begin
                       if (equipoAlumno[i].CuestionHace) then
                             if not equipoAlumno[i].CuestionTerminada then
                               equipoalumno[i].cargarEvaluacionCuestion(g_cuestion.solucion,respuesta,tiempor);
                       break;
                    end;
            end;


    end;
Procedure TfrmPresenta.ZoomImagen();
    var
        lima,tima,wima,hima:integer;
    begin
        hima:= f_HeightI+round(f_HeightI*0.20*f_Zoom);
        wima:= f_WidthI+round(f_WidthI*0.20*f_Zoom);
        lima:= f_LeftI-round(f_WidthI*0.10*f_Zoom);
        tima:= f_TopI-round(f_HeightI*0.10*f_Zoom);
        if (hima<=0) or (wima<=0) then
           begin
               bitmenos.enabled:=false;
               exit;
           end;
        imgpresenta.autosize:=false;
        imgpresenta.SetBounds(lima,tima,wima,hima);
        imgpresenta.Stretch:=true;
    end;

Procedure TfrmPresenta.TodosPresentar();
    var
        i:integer;
    begin
        iniciarServidorVNC();
        application.ProcessMessages;
        for i:=0 to high(equipoalumno) do
        begin
            equipoalumno[i].mostrar();
            Application.ProcessMessages;
            sleep(100);
        end;
    end;

Procedure TfrmPresenta.TodosCerrarNavegador();
      var
          i:integer;
      begin
          for  i:=0 to g_num_ord_aula-1 do
                 equipoAlumno[i].internetNo();
      end;

procedure Tfrmpresenta.TocarSonido();
    begin
       // Ejecutar(pchar(ORD_CERRAR_XMMS));
        application.ProcessMessages;
       // ordenesaula(ORD_TOCAR_SONIDO,[f_SonidoPresetar]);
        application.ProcessMessages;
    end;

procedure Tfrmpresenta.TocarParar();
    begin
       // ordenesaula(ORD_TOCAR_PARAR,[f_SonidoPresetar]);
        application.ProcessMessages;
    end;

procedure TfrmPresenta.spdarratonclick(sender:Tobject);
    var
        i,nor:integer;
    begin
        nor:=(sender as Tspeedbutton).tag;
        if f_DarRaton[nor]=false then
            begin
                for i:=low(f_darRaton) to high(f_DarRaton) do
                   f_DarRaton[i]:=false;
                application.ProcessMessages;
                lblraton.Caption:='Ratón: '+equipoalumno[nor].NombreMonitor;
                lblraton.Visible:=true;
                f_DarRaton[nor]:=true;
                AlumnoRatonSi(nor);
            end
        else
            begin
                f_DarRaton[nor]:=false;
                AlumnoRatonNo(nor);
                lblraton.Visible:=false;
            end;
    end;
procedure TfrmPresenta.OcultarPresenta();
    var
        i:integer;
    begin
        for i:=0 to g_num_ord_aula-1 do
            equipoAlumno[i].mostrarNo();
        application.ProcessMessages;
        for i:=0 to high(f_DarRaton) do
            begin
                spdarraton[i].down:=false;
                f_DarRaton[i]:=false;
            end;
       // if (g_Display='1') and g_IniciadaSesion then  AulaCerrarCanon;
        application.ProcessMessages;
        iniciarServidorVNC();;
    end;

procedure TfrmPresenta.MaxiMini(var Maximizandos:boolean);
    Const
        TOPBUTSIN:integer=705;TOPBUTCON:integer=558;TOPPANSIN:integer=22;
        LEFPANSIN:integer=23;WHIPANSIN:integer=977;HEIPANSIN:integer=660;
    var
        i,tb:integer;
    begin
        if Maximizandos then
            begin
                tb:=TOPBUTCON;
                pnpresenta.SetBounds(0,0,width,height);
            end
        else
            begin
                tb:=TOPBUTSIN;
                pnpresenta.SetBounds(LEFPANSIN,TOPPANSIN,WHIPANSIN,HEIPANSIN);
                metexto.SetBounds(0,0,pnpresenta.Width,pnpresenta.Height);
            end;
        for i:=0 to controlcount-1 do
            begin
                if (Controls[i] is Tbitbtn) then
                    (controls[i] as Tbitbtn).top:=tb;
            end;
        cbopresenta.Visible:=not Maximizandos;
        Maximizandos:=not maximizandos;
    end;

procedure TfrmPresenta.LineaClick(Sender: TObject);
    begin
        imgPresenta.canvas.Pen.Width:=strtoint((sender as Tlabel).caption);
        shagrosor.Left:=(sender as Tlabel).Left -1 ;
        shagrosor.top:=(sender as Tlabel).top -1
    end;
Function Tfrmpresenta.ImagenConSonido(const sAr:string):boolean;
    const
        EXT_SON:array [0..3]of string=('mp3','MP3','wav','WAV');
    var
        nomson,arcSon:string;
        i,lonson:integer;
    begin
        result:=false;
        lonson:=length(sar)-3;
        arcson:= copy(sar,0,lonson);
        for i:=low(EXT_SON) to high(EXT_SON) do
            begin
                nomson:=arcson+ EXT_SON[i];
                if fileexists(nomson) then
                    begin
                        result:=true;
                        f_SonidoPresetar:=nomson;
                    end;
            end
    end;

procedure TfrmPresenta.HacerSubRayar(amano: boolean);
    begin
        if lblcolorsub[1].Enabled=false then
            begin
                imgPresenta.Canvas.Pen.Width:=20;
                imgPresenta.Canvas.Pen.Color:=$00FEC0FF;
                shagrosor.Left:= lblsub[1].Left-1;
                shagrosor.Top:=lblsub[1].Top-1;
                shacolor.Left:= lblcolorsub[1].Left-1;
                shacolor.Top:=lblcolorsub[1].Top-1
            end;
        ActivarSub;
        Deselegir;
        imgPresenta.Canvas.Pen.Mode:=pmnotxor;
        imgpresenta.Cursor:=crIBeam;
        f_Mano:=amano;
    end;
Procedure TfrmPresenta.HacerPintar(amano:boolean);
    begin
        if lblcolorlin[1].Enabled=false then
            begin
                imgPresenta.Canvas.Pen.Width:=1;
                imgPresenta.Canvas.Pen.Color:=clblack;
                ColocarShape;
            end;
        ActivarPintar;
        Deselegir;
        f_Mano:=amano;
        imgPresenta.Canvas.Pen.Mode:=pmCopy;
        imgpresenta.Cursor:=crArrow;
    end;

procedure TfrmPresenta.Deselegir();
    begin
        bitmano.Down:=false;
        bitsubmano.Down:=false;
        bitlinea.Down:=false;
        bitsublinea.Down:=false;
    end;

procedure TfrmPresenta.CrearPintar();
    var
        i:integer;
        tbl:integer;
    begin
        for i:=1 to 10 do
          begin
              tbl:=41+(i-1)*26;
              lbllinea[i]:=Tlabel.Create(self);
              with lbllinea[i] do
                  begin
                      Caption:=inttostr(i);
                      AutoSize:=false;
                      Color:=clwhite;
                      Transparent:=false;
                      Tag:=i;
                      borderstyle:=bsSingle;
                      alignment:=tacenter;
                      Layout:=tlcenter;
                      Font.Name:='Sans';
                      Font.Size:=11;
                      visible:=true;
                      SetBounds(10,tbl,24,24);
                      Onclick:=@lineaclick;
                      enabled:=false;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
              lblColorLin[i]:=Tlabel.Create(self);
              with lblColorLin[i] do
                  begin
                      Caption:='';
                      AutoSize:=false;
                      Transparent:=false;
                      Tag:=i;
                      enabled:=false;
                      borderstyle:=bsSingle;
                      color:=COLORES_PINTAR[i];
                      SetBounds(46,tbl,24,24);
                      Onclick:=@colorclick;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
          end;
             for i:=1 to 4 do
             begin
               tbl:=347+(i-1)*26;
              lblSub[i]:=Tlabel.Create(self);
              with lblsub[i] do
                  begin
                      Caption:=inttostr(15+i*5);
                      AutoSize:=false;
                      Color:=clwhite;
                      Transparent:=false;
                      Tag:=i;
                      borderstyle:=bsSingle;
                      alignment:=tacenter;
                      Layout:=tlcenter;
                      Font.Name:='Sans';
                      Font.Size:=11;
                      SetBounds(10,tbl,24,24);
                      enabled:=false;
                      Onclick:=@lineaclick;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
               lblColorSub[i]:=Tlabel.Create(self);
               with lblColorSub[i] do
                  begin
                      Caption:='';
                      AutoSize:=false;
                      Transparent:=false;
                      Tag:=i;
                      borderstyle:=bsSingle;
                      enabled:=false;
                      color:=COLORES_SUBRAYAR[i];
                      SetBounds(46,tbl,24,24);
                      Onclick:=@colorclick;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
              end
    end;

procedure TfrmPresenta.CrearDarRaton;
    var
        i:integer;
    begin
        setlength(spdarraton,g_num_ord_aula);
        setlength(f_DarRaton,g_num_ord_aula);
        for i:=0 to g_num_ord_aula-1 do
            f_DarRaton[i]:=false;
        for i:= 0 to g_num_ord_aula-1 do
            begin
                spdarraton[i]:= TspeedButton.Create(self);
                with spdarraton[i] do
                    begin
                        GroupIndex:=101;
                        Down:=false;
                        AllowAllUp:=true;
                        Visible:=true;
                        SetBounds(3+22*i,3,22,22);
                        margin:=3;
                        font.Name:='Helvetica';
                        font.Size:=12;
                        Layout:=blGlyphLeft;
                        Parent:=pnRaton;
                        tag:=i;
                        Cursor:=crarrow;
                        Transparent:=true;
                        OnClick:=@spdarratonclick;
                        ShowHint:=true;
                        Caption:=inttostr(i+1);
                        with equipoalumno[i] do
                            begin
                                Enabled:=EstadoActivadEquipo in [eUsuario,eEncendido];
                                Hint:=ifthen(Enabled,NombreMonitor,NombreMonitor+'-Apagado');
                            end;
                        visible:=true;
                    end;
            end;
        pnraton.width:=22*g_num_ord_aula+10;
        pnraton.height:=32
    end;

procedure TfrmPresenta.CrearArbol();
    begin
         //
    end;

procedure TfrmPresenta.ColorClick(Sender: TObject);
    begin
        imgpresenta.Canvas.Pen.Color:=(sender as Tlabel).Color;
        shaColor.Left:=(sender as Tlabel).Left -1;
        shaColor.top:=(sender as Tlabel).top -1
    end;

Procedure Tfrmpresenta.ColocarImagen();
    var
        lima,tima,wima,hima:integer;
        prop,pr1,pr2:single;
    begin
        imgpresenta.autosize:=true;
        imgpresenta.Stretch:=false;
        f_Wreal:=f_anchoImg;
        f_Hreal:=f_altoImg;
        wima:=f_anchoImg;
        hima:=f_altoImg;
        if ((wima>ANCHO_IMAGEN) and (hima>ALTO_IMAGEN))then
        begin
             pr1:=ALTO_IMAGEN/hima;
             pr2:=ANCHO_IMAGEN/wima;
             if pr1 < pr2 then
                 prop:= pr1
             else
                 prop:= pr2;
             hima:= round(hima*prop);
             wima:= round(wima*prop);
             lima:= (ANCHO_IMAGEN-wima) div 2;
             tima:=  (ALTO_IMAGEN-hima) div 2;
             imgpresenta.autosize:=false;
             imgpresenta.SetBounds(lima,tima,wima,hima);
             imgpresenta.Stretch:=true;
        end
        else if (hima>ALTO_IMAGEN)  then
            begin
                prop:=ALTO_IMAGEN/hima;
                hima:=ALTO_IMAGEN;
                wima:= round(wima*prop);
                tima:=0;
                lima:= (ANCHO_IMAGEN-wima) div 2;
                imgpresenta.autosize:=false;
                imgpresenta.SetBounds(lima,tima,wima,hima);
                imgpresenta.Stretch:=true;
               end
        else if (wima>ANCHO_IMAGEN)then
                begin
                prop:=ANCHO_IMAGEN/wima;
                wima:=ANCHO_IMAGEN;
                hima:= round(hima*prop);
                lima:=0;
                tima:= (ALTO_IMAGEN-hima) div 2;
                imgpresenta.autosize:=false;
                imgpresenta.SetBounds(lima,tima,wima,hima);
                imgpresenta.Stretch:=true;
                end
        else
            begin
                lima:=(ANCHO_IMAGEN-wima) div 2;
                tima:=(ALTO_IMAGEN-hima) div 2;
                imgpresenta.Stretch:=false;
                imgpresenta.left:=lima;
                imgpresenta.top:=tima;
            end;
        f_LeftI:=imgpresenta.Left;
        f_TopI:=imgpresenta.Top;
        f_WidthI:=imgpresenta.Width;
        f_HeightI:=imgpresenta.Height;
        imgpresenta.Visible:=true;
  end;

procedure Tfrmpresenta.CierraSonido();
    begin
      //  Ejecutar('xmms -s &');
        application.ProcessMessages;
     //   Ejecutar(pchar(ORD_CERRAR_XMMS));
     //  application.ProcessMessages;
     //   sleep(500);
    end;

procedure TfrmPresenta.ColocarShape;
    begin
        shagrosor.Left:= lbllinea[1].Left-1;
        shagrosor.Top:=lbllinea[1].Top-1;
        shacolor.Left:=lblcolorlin[1].Left-1;
        shacolor.Top:=lblcolorlin[1].Top-1;
    end;
procedure Tfrmpresenta.CargarTexto(sArc:string);
    begin
        sArc:=g_directorio_presentacion+PathDelim+sArc;
        try
            imgpresenta.Visible:=false;
            metexto.Visible:=true;
            //tbrweb.Visible:=false;
           // bithtmatras.Visible:=false;
           // bithtmhome.Visible:=false;
          //  bithtmadelante.visible:=false;
            metexto.Lines.LoadFromFile(sarc);
            application.ProcessMessages;
            bitmas.Enabled:=false;
            bitmenos.Enabled:=false;
            bitpintar.Enabled:=false;
            bitcursor.Enabled:=false;
            bitsonidos.Enabled:=false;
            pnpintar.Visible:=false;
            pnraton.visible:=false;
            metexto.ReadOnly:=true;
        except
            mensaje(MEN_ERROR_ARCHIVO,aceptar)
        end;
    end;
procedure Tfrmpresenta.CargarImagen(sArc:string;tipo:integer);
    var
        imgyson:boolean;
        png:TPortableNetworkGraphic;
        jpg:TJPEGImage;
        bmp:TBitmap;
    begin
    try
        sArc:=g_directorio_presentacion+PathDelim+sArc;
        metexto.Visible:=false;
             case tipo of
                0:
                    begin
                        png:=TPortableNetworkGraphic.create;
                        try
                            DimensionPNG(sArc,f_anchoImg,f_altoImg);
                            png.loadfromfile(sArc);
                            imgpresenta.Picture.Bitmap.Assign(png);
                        finally
                            png.Free;
                        end;
                    end;
                1:
                    begin
                        jpg:=TJPEGImage.create;
                        try
                            DimensionJPG(sArc,f_anchoImg,f_altoImg);
                            jpg.loadfromfile(sArc);
                            imgpresenta.Picture.Bitmap.Assign(jpg);
                        finally
                            jpg.Free;
                        end;
                    end;
                2:
                    begin
                        bmp:=TBitmap.create;
                        try
                            DimensionBMP(sArc,f_anchoImg,f_altoImg);
                            bmp.loadfromfile(sArc);
                            imgpresenta.Picture.Bitmap.Assign(bmp);
                        finally
                            bmp.Free;
                        end;
                    end;
             end;
        imgpresenta.autosize:=false;
        imgPresenta.Width:=f_anchoImg;
        imgPresenta.Height:=f_altoImg;
        imgpresenta.autosize:=true;
        HacerPintar(true);
        f_Zoom:=0;
        bitmas.Enabled:=true;
        bitmenos.Enabled:=true;
        bitpintar.Enabled:=not pnpintar.visible;
        pnraton.Visible:= not bitmostrar.Enabled;
        bitcursor.Enabled:= pnpintar.visible;
        application.ProcessMessages;
        colocarimagen;
        application.ProcessMessages;
       imgyson:=ImagenConSonido(sarc);
          if imgyson then tocarsonido;
              bitsonidos.Enabled:=imgyson;
            except
                begin
                    mensaje(MEN_ERROR_ARCHIVO,aceptar);
                    exit;
                end;
            end;
    end;

procedure Tfrmpresenta.CargarHtm(sArch:string);
    begin
    sArch:=g_directorio_presentacion+PathDelim+sArch;
    (*    //archivo de tip htm o html
        try
            imgpresenta.Visible:=false;
            metexto.Visible:=false;
            tbrweb.LoadFromFile(sArch);
            tbrweb.Visible:=true;
            bithtmatras.Visible:=true;
            bithtmhome.Visible:=true;
            bithtmadelante.visible:=true;
            application.ProcessMessages;
            bitmas.Enabled:=false;
            bitmenos.Enabled:=false;
            bitpintar.Enabled:=false;
            bitcursor.Enabled:=false;
            bitsonidos.Enabled:=false;
            gbpintar.Visible:=false;
            gbraton.visible:=false;
        except
            mensaje(MEN_ERROR_ARCHIVO,aceptar)
        end;  *)
     end;

Procedure tfrmPresenta.CargarArchivo();
    var
        sArchivo,snomarc,snomarc4:string;
    begin
        if length(cbopresenta.Text)<3 then exit;
        sArchivo:=cbopresenta.Items.Strings[f_NumeroImagen];
        snomarc:=rightstr(sArchivo,3);
        snomarc:=AnsiLowerCase(snomarc);
        snomarc4:=rightstr(sArchivo,4);
        snomarc4:=AnsiLowerCase(snomarc4);
        if (snomarc = 'png')  then
            CargarImagen(sArchivo,0)
        else if (snomarc = 'jpg') then
            CargarImagen(sArchivo,1)
        else if (snomarc = 'bmp') then
            CargarImagen(sArchivo,2)
        else if (snomarc = 'txt') or (snomarc = 'TXT') then
            CargarTexto(sArchivo);
        pnminimizar.BringToFront;
       // else if (snomarc = 'htm') or  (snomarc4 = 'html') then
       //     CargarHtm(sarchivo);
    end;
procedure TfrmPresenta.BuscaFicheros(Ruta, Mascara : AnsiString; var Value : TStringList; brec : Boolean);
    var
        srBuscar : TSearchRec;
        iEncontrado : Integer;
    begin
        if Ruta[Length(Ruta)] <> '/' then Ruta := Ruta +'/';
        iEncontrado := FindFirst(Ruta+Mascara, faAnyFile-faDirectory, srBuscar);
        while iEncontrado = 0 do
            begin
                if ( srBuscar.Name <> '.' ) and ( srBuscar.Name <> '..' ) and ( srBuscar.Name <> '' ) then
                    Value.Add(Ruta+srBuscar.Name);
                iEncontrado := FindNext(srBuscar);
            end;
        FindClose(srBuscar);
    end;
procedure TfrmPresenta.BuscaFicherosEncuesta(Ruta, Mascara : AnsiString; var Value : TStringList; brec : Boolean);
    var
        srBuscar : TSearchRec;
        iEncontrado : Integer;
    begin
        if Ruta[Length(Ruta)] <> '/' then Ruta := Ruta +'/';
        iEncontrado := FindFirst(Ruta+Mascara, faAnyFile-faDirectory, srBuscar);
        while iEncontrado = 0 do
            begin
                if ( srBuscar.Name <> '.' ) and ( srBuscar.Name <> '..' ) and ( srBuscar.Name <> '' ) then
                    Value.Add(ExtractFileNameOnly(srBuscar.Name));
                iEncontrado := FindNext(srBuscar);
            end;
        FindClose(srBuscar);
    end;
Procedure TfrmPresenta.AulaCerrarCanon;
  (*  var
        i:integer;
        f_SesionCerrar,shostalu:string;*)
    begin
     (*  f_SesionCerrar:='ssh aulalinex-alumno@%s killall x-session-manager & 2>>/dev/null';
       for  i:=0 to g_num_ord_aula-1 do
            begin
                if (equipoalumno[i].EstadoActivadEquipo in [eEncendido,eUsuario]) then
                    begin
                        shostalu:=NumeroNombreOrdenador(i);
                        OrdenesAula(f_SesionCerrar,[shostalu]);
                        sleep(100);
                    end;
                application.ProcessMessages;
            end ;
        g_IniciadaSesion:=false;*)
    end;

Procedure TfrmPresenta.AulaCanonAbrir;
  (*  var
        shostalu:string;
        i,ncontador:integer;
        f_InicioSesion:string; *)
    begin
        (*f_InicioSesion:='ssh aulalinex-alumno@%s startx -- :1 & 2>>/dev/null';
        for  i:=0 to g_num_ord_aula-1 do
            begin
                shostalu:=NumeroNombreOrdenador(i);
                OrdenesAula(f_InicioSesion,[shostalu]);
                sleep(1000);
                application.ProcessMessages;
            end ;
        ncontador:=0;
        while ncontador <g_CanonTiempo*10 do
            begin
                sleep(80);
                application.ProcessMessages;
                inc(ncontador);
            end;
           g_IniciadaSesion:=true;*)
    end;
procedure Tfrmpresenta.ApagaSonido();
    begin
       //  ordenesaula(ORD_APAGAR_SONIDO,[f_SonidoPresetar]);
         application.ProcessMessages;
    end;
Procedure TfrmPresenta.ApagarSalva;
      var
          i:integer;
      begin
          //Desconecta salvapantallas de los alumnos
          for  i:= 0 to g_num_ord_aula-1 do
               equipoalumno[i].apagasalva;

      end;

procedure TfrmPresenta.AlumnoRatonNo(nord:integer);
    begin
       equipoAlumno[nord].ratonNo();
       f_AmoRaton:=-1;
    end;

procedure TfrmPresenta.AlumnoRatonSi(nord:integer);
    begin
        if (f_AmoRaton<> -1)then AlumnoRatonNo(f_AmoRaton);
        equipoAlumno[nord].raton();
        f_AmoRaton:=nord;
    end;

procedure TfrmPresenta.ActivarPintar();
    var i:integer;
    begin
        for i:=1 to 10 do
            begin
                with lbllinea[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
                with lblcolorlin[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
            end;
        for i:=1 to 4 do
            begin
                with lblColorSub[i]do
                    begin
                        enabled:=false;
                        cursor:=crdefault;
                        showhint:=false;
                    end;
                with lblSub[i]do
                    begin
                        enabled:=false;
                        cursor:=crarrow;
                        showhint:=false;
                    end;
            end;
    end;

procedure TfrmPresenta.ActivarSub();
    var
        i:integer;
    begin
        for i:=1 to 10 do
            begin
                with lblcolorlin[i] do
                    begin
                        enabled:=false;
                        cursor:=crdefault;
                        showhint:=false;
                    end;
            end;
        for i:=1 to 10 do
            begin
                with lbllinea[i] do
                    begin
                        enabled:=false;
                        cursor:=crarrow;
                        showhint:=false;
                    end;
            end;
        for i:=1 to 4 do
            begin
                with lblcolorSub[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
            end;
        for i:=1 to 4 do
            begin
                with lblSub[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
            end;
    end;



procedure TfrmPresenta.imgPresentaMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
   var wactual,hactual:integer;
    begin
        if f_Pintando=false then
            begin
                if button = mbleft then
                    begin
                        f_xi:=X;
                        f_yi:=Y;
                        imgpresenta.Cursor:=crSizeall;
                        f_Activado:=true;
                    end;
            end
        else
            begin
                  wactual:=imgpresenta.Width;
                  hactual:=imgpresenta.Height;
                  f_Wratio:=(wactual/f_Wreal);
                  f_Hratio:=(hactual/f_Hreal);
                if f_Mano then
                    begin
                        if Button = mbLeft then
                            begin
                                f_Drawing := True;
                                f_LastPos := Point(round(X/f_Wratio), round(Y/f_Hratio));
                            end;
                    end
                else
                    begin
                        if bpinchado=false then
                                begin
                                    bpinchado:=true;
                                    imgpresenta.Canvas.MoveTo(round(X/f_Wratio), round(Y/f_Hratio));
                                end
                        else
                             begin
                                bpinchado:=false;
                                imgpresenta.Canvas.lineto(round(X/f_Wratio), round(Y/f_Hratio))
                             end;
                    end;
            end;
    end;

procedure TfrmPresenta.imgPresentaMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
    begin
        if (not f_Pintando) and f_Activado then
            begin
                f_xf:=X;
                f_yf:=Y;
                imgpresenta.Left:=imgpresenta.Left +(f_xf-f_xi);
                imgpresenta.Top:= imgpresenta.top +(f_yf-f_yi);
                application.ProcessMessages;
            end
        else if f_Pintando and f_Drawing and f_Mano then
            begin
                imgpresenta.Canvas.MoveTo(f_LastPos.X, f_LastPos.Y);
                f_LastPos := Point(round(X/f_Wratio), round(Y/f_Hratio));
                imgpresenta.Canvas.LineTo(f_LastPos.X, f_LastPos.Y)
            end;
    end;

procedure TfrmPresenta.imgPresentaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
   begin
        if f_Pintando=false then
            begin
                if button = mbleft then
                    begin
                        f_xf:=X;
                        f_yf:=Y;
                        imgpresenta.Cursor:=crarrow;
                        imgpresenta.Left:=imgpresenta.Left +(f_xf-f_xi);
                        imgpresenta.Top:= imgpresenta.top +(f_yf-f_yi);
                        f_Activado:=false;
                    end;
            end
        else
            if f_Mano and (Button = mbLeft) then
                f_Drawing := False;
    end;

procedure TfrmPresenta.mnuAmpliarClick(Sender: TObject);
    begin
        bitmasclick(bitmas);
    end;

procedure TfrmPresenta.mnuAnteriorClick(Sender: TObject);
    begin
        bitanteriorclick(bitanterior);
    end;

procedure TfrmPresenta.mnuApagarClick(Sender: TObject);
    begin
        Apagarsalva();
    end;

procedure TfrmPresenta.mnuDesconectarClick(Sender: TObject);
    begin
        TodosCerrarNavegador();
    end;

procedure TfrmPresenta.mnuMostrarClick(Sender: TObject);
    begin
        if mnumostrar.tag =0  then
            begin
                bitMostrarClick(bitMostrar);
                mnumostrar.tag:=1;
                mnumostrar.ImageIndex:=3;
            end
        else
            begin
                bitOcultarclick(bitocultar);
                mnumostrar.tag:=0;
                mnumostrar.ImageIndex:=2;
            end
    end;

procedure TfrmPresenta.mnuReducirClick(Sender: TObject);
    begin
        bitmenosclick(bitmenos);
    end;

procedure TfrmPresenta.mnuSiguienteClick(Sender: TObject);
    begin
        bitsiguienteclick(bitsiguiente);
    end;

procedure TfrmPresenta.mnuVerClick(Sender: TObject);
    begin
        if mnuver.tag=0 then
            begin
                bitPintarClick(bitpintar);
                mnuver.tag:=1;
                mnuver.ImageIndex:=9;
            end
        else
            begin
                bitCursorClick(bitcursor);
                 mnuver.tag:=0;
                 mnuver.ImageIndex:=8;
            end;
    end;

procedure TfrmPresenta.tmrMensajeTimer(Sender: TObject);
    begin
        f_contador_mensaje:=f_contador_mensaje-1;
        lblTiempo2.caption:=Tiempo(f_contador_mensaje);
        if f_contador_mensaje<=0 then
            begin
                tmrMensaje.enabled:=false;
                lblMenTiempo.Caption:=MEN_ORG_RESULTADOS;
            end;
    end;

procedure TfrmPresenta.tmrRecogidaTimer(Sender: TObject);
    var
        i:integer;
        todasrrecogidas:Boolean;
    begin
        todasrrecogidas:=true;
        f_cuestion_contador:=f_cuestion_contador-1;
       for i:=0 to high(equipoalumno) do
            begin
                  if equipoalumno[i].CuestionHace then
                      if equipoalumno[i].CuestionTerminada=false then
                          todasrrecogidas:=false;

            end;
        if todasrrecogidas or (f_cuestion_contador<=0) then
            begin
                tmrMensaje.enabled:=false;
                tmrRecogida.enabled:=false;
                lblMenTiempo.Caption:=MEN_ORG_RESULTADOS;
                for i:=0 to high(equipoalumno) do
                    begin
                          if equipoalumno[i].CuestionHace then
                              if equipoalumno[i].CuestionTerminada=false then
                                  anadirRespuesta(equipoAlumno[i].ip,0,g_cuestion.tiempo);

                    end;
                MostrarEstadisticasCuestion();
            end;
    end;

procedure TfrmPresenta.bitAnteriorClick(Sender: TObject);
    begin
        try
            bpinchado:=false;
            ApagaSonido;
            bitsiguiente.Enabled:=true;
            mnusiguiente.Enabled:=true;
            if f_NumeroImagen > 0 then f_NumeroImagen:=f_NumeroImagen-1;
            cbopresenta.Text:=cbopresenta.Items.Strings[f_NumeroImagen];
            CargarArchivo;
            if f_NumeroImagen <1 then
                begin
                    bitanterior.Enabled:=false;
                    mnuanterior.Enabled:=false
                end;
        except
            begin
                mensaje(MEN_ERROR_MOSTRAR,aceptar);
                close;
            end;
        end;
    end;

procedure TfrmPresenta.bitApagarSalvaClick(Sender: TObject);
    begin
        Apagarsalva;
    end;

procedure TfrmPresenta.bitCargarClick(Sender: TObject);
    begin
         //rmElegir.ShowModal;
    end;

procedure TfrmPresenta.bitCerrarClick(Sender: TObject);
    begin
         close;
    end;

procedure TfrmPresenta.bitCursorClick(Sender: TObject);
    begin
        mnuver.Caption:='Ver paleta';
        mnuver.ImageIndex:=8;
        mnuver.tag:=0;
        f_Pintando:=false;
        imgpresenta.Cursor:=crarrow;
        pnpintar.Visible:=false;
        bitpintar.Enabled:=true;
        bitcursor.Enabled:=false;
    end;

procedure TfrmPresenta.bitLineaClick(Sender: TObject);
    begin
        bpinchado:=false;
        HacerPintar(false);
    end;

procedure TfrmPresenta.bitManoClick(Sender: TObject);
    begin
        HacerPintar(true);
    End;

procedure TfrmPresenta.bitMasClick(Sender: TObject);
    begin
        if (f_Zoom <10) then
            begin
                f_Zoom:=succ(f_Zoom);
                ZoomImagen;
                bitmenos.Enabled:=true;
                mnureducir.Enabled:=true;
            end
        else
            begin
                bitmas.Enabled:=false;
                mnuampliar.Enabled:=false;
            end;
    end;

procedure TfrmPresenta.bitMaximizarClick(Sender: TObject);
    begin
       // bitminimizar.Visible:=f_Maximizando;
       pnminimizar.Visible:=f_Maximizando;
        maximini(f_Maximizando);
        if pnpresenta.Color=clblack then
            begin
                pnpresenta.Color:=clwhite;
                lblRaton.font.Color:=clblack
            end
        else
            begin
                pnpresenta.Color:=clblack;
                lblRaton.font.Color:=clwhite
            end;
       pnminimizar.BringToFront;
    end;

procedure TfrmPresenta.bitMenosClick(Sender: TObject);
    begin
        if (f_Zoom >-10) then
            begin
                f_Zoom:=pred(f_Zoom);
                ZoomImagen;
                bitmas.Enabled:=true;
                mnuampliar.Enabled:=true;
            end
        else
            begin
                bitmenos.Enabled:=false;
                mnureducir.Enabled:=false;
            end;
    end;

procedure TfrmPresenta.bitMostrarClick(Sender: TObject);
    begin
        mnumostrar.Caption:='Ocultar presentación';
        mnumostrar.ImageIndex:=3;
        mnumostrar.tag:=1;
        enabled:=false;
        bitmostrar.Enabled:=false;
        if (g_Display='1') and not g_IniciadaSesion then
        AulaCanonAbrir;
        application.ProcessMessages;
        TodosPresentar;
        bitocultar.Enabled:=true;
        enabled:=true;
        pnraton.Visible:=true;
    end;

procedure TfrmPresenta.bitNoNavegarClick(Sender: TObject);
    begin
        TodosCerrarNavegador;
    end;

procedure TfrmPresenta.bitOcultarClick(Sender: TObject);
      begin
        mnumostrar.Caption:='Mostrar presentación';
        mnumostrar.ImageIndex:=2;
        mnumostrar.tag:=0;
        application.ProcessMessages;
        OcultarPresenta;
        bitmostrar.Enabled:=true;
        bitocultar.Enabled:=false;
        application.ProcessMessages;
        pnraton.Visible:=false;
    end;

procedure TfrmPresenta.bitPintarClick(Sender: TObject);
    begin
        mnuver.Caption:='Ocultar paleta';
        mnuver.ImageIndex:=9;
        mnuver.tag:=1;
        f_Pintando:=true;
        imgpresenta.Cursor:=crdrag;
        f_Drawing:=false;
        pnpintar.Visible:=true;
        pnpintar.Enabled:=true;
        pnpintar.BorderStyle:=bsSingle;
        bitpintar.Enabled:=false;
        bitcursor.Enabled:=true;
        HacerPintar(true);
    end;

procedure TfrmPresenta.bitPruebaClick(Sender: TObject);
    var
        stream:TStringList;
    begin
        EncuestasLabelsOriginal();
        stream:=TStringList.create;
        try
            if not DirectoryExists(equipoProfesor.DirCuestiones) then
               CreateDir(equipoProfesor.DirCuestiones);
            BuscaFicherosEncuesta(equipoProfesor.DirCuestiones,'*.txt',stream,true);
            if stream.Count>0 then
                begin
                    cboCuestion.items.Assign(stream);
                    cboCuestion.Font.Color:=clred;
                    cboCuestion.visible:=true;
                    cboPresenta.Visible:=false;
                    cboCuestion.Enabled:=true;
                end
            else
                 Mensaje(MEN_NO_CONSULTAS,aceptar);
        finally
           stream.free;
        end;
    end;

procedure TfrmPresenta.bitSiguienteClick(Sender: TObject);
    begin
        try
            ApagaSonido;
            application.ProcessMessages;
            mnuanterior.Enabled:=true;
            bitanterior.Enabled:=true;
            f_NumeroImagen:=f_NumeroImagen+1;
            cbopresenta.Text:=cbopresenta.Items.Strings[f_NumeroImagen];
            CargarArchivo;
            bpinchado:=false;
            if f_NumeroImagen>=cbopresenta.Items.Count-1 then
                 begin
                     bitsiguiente.Enabled:=false;
                     mnusiguiente.Enabled:=false;
                 end;
        except
            begin
                mensaje(MEN_ERROR_MOSTRAR,aceptar);
                close;
            end;
        end;
    end;

procedure TfrmPresenta.bitSonidosClick(Sender: TObject);
    begin
         TocarParar
    end;

procedure TfrmPresenta.bitSubLineaClick(Sender: TObject);
    begin
        hacersubrayar(false);
        bpinchado:=false;
    end;

procedure TfrmPresenta.bitSubManoClick(Sender: TObject);
    begin
        HacerSubrayar(true);
    end;

procedure TfrmPresenta.btnCerrarCuestionClick(Sender: TObject);
    begin
       if f_consulta_enviada then
          if Mensaje(MEN_ENCUESTA_ACTIVA,sino)=2 then exit;
       btnIndividual.Enabled:=false;
       btnOpciones.Enabled:=false;
       btnResultados.Enabled:=false;
       bchOpciones.visible:=false;
       pnEcuesta.visible:=false;
       bitPrueba.Enabled:=true;
       cboCuestion.visible:=false;
       cboPresenta.visible:=true;
       cboCuestion.ItemIndex:=-1;
       cboCuestion.Text:=MEN_SELECCIONA_CUESTION;
       Application.ProcessMessages;
       pnEstadisticas1.Visible:=false;
       if idCMDTCPServer1.Active=true then
               idCMDTCPServer1.Active:=false;
    end;

procedure TfrmPresenta.btnEnviarClick(Sender: TObject);
    begin
        EnviarConsulta(cboCuestion.text);
        lblMenTiempo.caption:=MEN_RECOGIENDO_RESPUESTAS;
        lblMenTiempo.visible:=true;
        lblTiempo2.visible:=true;
    end ;

procedure TfrmPresenta.btnIndividualClick(Sender: TObject);
    begin
        IndividualMostrarEstadisticas();
        pnEstadisticas1.BringToFront;
        pnEstadisticas1.visible:=false;
    end;

procedure TfrmPresenta.btnOpcionesClick(Sender: TObject);
    begin
        OpcionesMostrarEstadisticas1(f_respuestas_recibidas);
        pnEstadisticas1.BringToFront;
        pnEstadisticas1.visible:=true
    end;

procedure TfrmPresenta.btnResultadosClick(Sender: TObject);
    begin
        ResultadosEstadisticas(g_cuestion.numaciertos,g_cuestion.numfallos,g_cuestion.numBlancos);
        pnEstadisticas1.BringToFront;
        pnEstadisticas1.visible:=true
    end ;

procedure TfrmPresenta.cboCuestionChange(Sender: TObject);
      begin
       if cboCuestion.ItemIndex=-1 then exit;
        equipoProfesor.ArcCuestion:=equipoProfesor.DirCuestiones+PathDelim+cbocuestion.text+'.txt';
        if not FileExists(equipoProfesor.ArcCuestion) then
            begin
                Mensaje(MEN_NO_EXISTE_CONSULTA,Aceptar);
                exit;
            end;
        if not EncuestaLeerArchivo(equipoProfesor.ArcCuestion) then exit ;
        EncuestaMostrar();
        btnEnviar.Enabled:=true;
        pnEcuesta.visible:=true;
       end;

procedure TfrmPresenta.cboPresentaChange(Sender: TObject);
  begin
        try
            ApagaSonido;
            if cbopresenta.itemindex <> -1 then
                begin
                    f_NumeroImagen:=cbopresenta.itemindex;
                    CargarArchivo;
                  end;
        except
            begin
                mensaje(MEN_ERROR_Mostrar,aceptar);
                close
            end;
        end;
        if f_NumeroImagen<=1 then
            begin
                mnuanterior.Enabled:=false;
                mnusiguiente.Enabled:=true;
                bitanterior.Enabled:=false;
                bitsiguiente.Enabled:=true;
            end
        else if f_NumeroImagen>=cbopresenta.Items.Count-1 then
            begin
                bitsiguiente.Enabled:=false;
                bitanterior.Enabled:=true;
                mnuanterior.Enabled:=true;
                mnusiguiente.Enabled:=false;
            end
        else
            begin
                bitsiguiente.Enabled:=true;
                bitanterior.Enabled:=true;
                mnuanterior.Enabled:=true;
                mnusiguiente.Enabled:=true;
            end;
      end;

procedure TfrmPresenta.FormClose(Sender: TObject; var CloseAction: TCloseAction
  );
    begin
        g_EstoyPresentando:=false;
        CloseAction:=caFree;
        //Ejecutar('killall xmms 2>> /dev/null')
    end;

procedure TfrmPresenta.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
         try
             if mensaje(MEN_SALIR,sino)=2 then
                 canclose:=false
             else
                 begin
                    CerrarServidorVnc;
                    // CierraSonido();
                   //  OcultarPresenta;
                   Application.ProcessMessages;
                    if idCMDTCPServer1.Active=true then
                        idCMDTCPServer1.Active:=false;
                   IniciarServidorVnc;

                  end;
         except
            // writeln('error al realizar la presetación')
         end
    end;

procedure TfrmPresenta.FormCreate(Sender: TObject);
    const
         TOPPANSIN:integer=24; LEFPANSIN:integer=24;WHIPANSIN:integer=976;HEIPANSIN:integer=658;
    begin
        setlength(g_cuestion.mejoresalumnos,g_num_ord_aula+1);
        setlength(g_cuestion.mejorestiempos,g_num_ord_aula+1);
        setlength(g_cuestion.mejoresequipos,g_num_ord_aula+1);
        setlength(g_cuestion.mejoresrespuestas,g_num_ord_aula);
        EncuestasCrearLabels();
        setbounds(0,0,1024,768);
        pnpresenta.SetBounds(LEFPANSIN,TOPPANSIN,WHIPANSIN,HEIPANSIN);
        pnEcuesta.SetBounds(LEFPANSIN,TOPPANSIN,WHIPANSIN,HEIPANSIN);
        iniciarServidorVNC();
        g_EstoyPresentando:=true;
        f_NumeroImagen:=0;
        f_Zoom:=0;
        //Ejecutar('xmms &');
        CrearArbol;
        CrearPintar;
        cboPresenta.Items.Assign(Ficheros);
        mnuanterior.Enabled:=false;
        bitanterior.Enabled:=false;
        if cbopresenta.Items.Count<2 then
            begin
                bitsiguiente.Enabled:=false;
                mnusiguiente.Enabled:=false;
            end;
        cbopresenta.ItemIndex := 0;
        cargararchivo;
        bpinchado:=false;
        f_Mano:=true;
        bitmano.OnClick(bitmano);
        bitmano.Down:=true;
        Activarsub;
        CrearDarRaton;
        cboCuestion.ItemIndex:=-1;
        cboCuestion.Text:='Selecciona una cuestión';
        BorderStyle:=bsNone;
        Application.ProcessMessages;
    end;

procedure TfrmPresenta.imgGraficoClick(Sender: TObject);
    begin

    end;

initialization
  {$I pantalla.lrs}

end.

